{Code Edit April to August 1998
 1.5 September 1999
 1.6 April 16, 2000
 2.0 June 2001}

{keywords for download.com:
 Code Edit, Code Edit 1.5, code, coding, edit, editor, text editor, programming, programming editor, code editor, free, freeware
 6-9-2001:
 Code Edit, code, coding, edit, editor, text editor, programming, programming editor, code editor, free, freeware, syntax highlighting, color coding
}
unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Menus,
  StdCtrls, ExtCtrls, Buttons, ComCtrls,
  ToolWin, Printers, FileCtrl, RichEdit, Spin,
  CE_Unit, ReuUnit, ShellAPI, clipbrd, ReservedWordsUnit;

const
  CT_DUAL = 0; CT_STACK = 1; CT_QUEUE = 2;

  //TU = tab use; see TTabUse
  TU_TAB = 0; TU_SPACES = 1;

type
  {function type so a function can be used for a parameter
   in procedure ChangeCaseWith}
  TFCstringstring = function(const str : string) : string;

  TGroupMenuItem = class (TMenuItem)
  public
    procedure Click; override;
    procedure Assign (Source : TPersistent); override;
  end;

  TRunMenuItem = class (TMenuItem)
  public
    procedure Click; override;
  end;

  TRecentMenuItem = class (TMenuItem)
  public
    procedure Suicide;
    procedure Click; override;
  end;

  TFavMenuItem = class (TMenuItem)
  public
    procedure Suicide;
    procedure Click; override;
  end;

  TTabUse = object
  public
    UseSpaces : boolean;
    TabSize : byte;

    constructor Init;
    procedure Load (const cb : TCheckBox; const se : TSpinEdit);
    procedure LoadFromFile (var FileVar : TextFile);
    procedure SaveToFile (var FileVar : TextFile);
    procedure Store (var cb : TCheckBox; var se : TSpinEdit);
  end;

  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    FileMnu: TMenuItem;
    FileOpenMnu: TMenuItem;
    FileSaveMnu: TMenuItem;
    FileSaveAsMnu: TMenuItem;
    FileExitMnu: TMenuItem;
    EditMnu: TMenuItem;
    OptionsMnu: TMenuItem;
    OptionsEnvironmentMnu: TMenuItem;
    N2: TMenuItem;
    FilePrintMnu: TMenuItem;
    N3: TMenuItem;
    OptionsFontMnu: TMenuItem;
    FileNewMnu: TMenuItem;
    EditCutMnu: TMenuItem;
    EditCopyMnu: TMenuItem;
    EditPasteMnu: TMenuItem;
    FileCloseMnu: TMenuItem;
    ViewMnu: TMenuItem;
    SearchMnu: TMenuItem;
    SearchFindMnu: TMenuItem;
    SearchSearchAgainMnu: TMenuItem;
    SearchReplaceMnu: TMenuItem;
    N1: TMenuItem;
    SearchGotoLineNumberMnu: TMenuItem;
    HelpMnu: TMenuItem;
    EditDeleteMnu: TMenuItem;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    ToolBar: TPanel;
    NewSpdBtn: TSpeedButton;
    OpenSpdBtn: TSpeedButton;
    PrintSpdBtn: TSpeedButton;
    SaveSpdBtn: TSpeedButton;
    FindSpdBtn: TSpeedButton;
    SearchAgainSpdBtn: TSpeedButton;
    ReplaceSpdBtn: TSpeedButton;
    FileSaveAllMnu: TMenuItem;
    CutSpdBtn: TSpeedButton;
    CopySpdBtn: TSpeedButton;
    PasteSpdBtn: TSpeedButton;
    FontDlg: TFontDialog;
    ViewNextMnu: TMenuItem;
    ViewPreviousMnu: TMenuItem;
    N6: TMenuItem;
    PopupMenu: TPopupMenu;
    NextPopItem: TMenuItem;
    PreviousPopItem: TMenuItem;
    N7: TMenuItem;
    CutPopItem: TMenuItem;
    CopyPopItem: TMenuItem;
    PastePopItem: TMenuItem;
    DeletePopItem: TMenuItem;
    N8: TMenuItem;
    PropertiesPopItem: TMenuItem;
    WrapMnu: TMenuItem;
    RunMnu: TMenuItem;
    OptionsRunMnu: TMenuItem;
    EditUndoMnu: TMenuItem;
    PrintDlg: TPrintDialog;
    PrinterSetupDlg: TPrinterSetupDialog;
    FilePrintSetupMnu: TMenuItem;
    NextSpdBtn: TSpeedButton;
    PreviousSpdBtn: TSpeedButton;
    ExecuteMnu: TMenuItem;
    ExecuteCurrentFileMnu: TMenuItem;
    ExecuteDOSPromptMnu: TMenuItem;
    OptionsExecuteMnu: TMenuItem;
    FileReloadMnu: TMenuItem;
    EditDeleteLineMnu: TMenuItem;
    ExecuteDOSComMnu: TMenuItem;
    OptionsReadOnlyMnu: TMenuItem;
    HelpAboutMnu: TMenuItem;
    UpDown1: TUpDown;
    N10: TMenuItem;
    EditCutLineMnu: TMenuItem;
    N12: TMenuItem;
    N11: TMenuItem;
    ExecuteSpdBtn: TSpeedButton;
    CloseSpdBtn: TSpeedButton;
    SaveAllSpdBtn: TSpeedButton;
    UndoSpdBtn: TSpeedButton;
    FileRecentMnu: TMenuItem;
    FileOpenGroupMnu: TMenuItem;
    OptionsOpenGroupMenu: TMenuItem;
    FileCopyMnu: TMenuItem;
    FileMoveMnu: TMenuItem;
    N16: TMenuItem;
    FileOperationsMnu: TMenuItem;
    FileRenameMnu: TMenuItem;
    FileDeleteMnu: TMenuItem;
    FileFavoritesMnu: TMenuItem;
    OptionsOpenFavoritesMnu: TMenuItem;
    FileAddMnu: TMenuItem;
    AddFavoritesMnu: TMenuItem;
    AddGroupMnu: TMenuItem;
    HelpContentsMnu: TMenuItem;
    ViewSelectFileMnu: TMenuItem;
    AddToPopItem: TMenuItem;
    ViewSpdBtn: TSpeedButton;
    N13: TMenuItem;
    HelpSpdBtn: TSpeedButton;
    FileBackupMnu: TMenuItem;
    FileBackupCurrentFileMnu: TMenuItem;
    FileBackupAllFilesMnu: TMenuItem;
    FileCloseCurrentFileMnu: TMenuItem;
    FileCloseGroupMnu: TMenuItem;
    FileCloseAllFilesMnu: TMenuItem;
    FileInsertMnu: TMenuItem;
    FileUnbackupMnu: TMenuItem;
    FileUnbackupCurrentFileMnu: TMenuItem;
    FileUnbackupAllFilesMnu: TMenuItem;
    N14: TMenuItem;
    FileReplaceMnu: TMenuItem;
    FileReplaceCurrentFileMnu: TMenuItem;
    FileReplaceAllFilesMnu: TMenuItem;
    Edit: TRichEdit;
    FileSelectionMnu: TMenuItem;
    FileSelectionSaveMnu: TMenuItem;
    FileSelectionOpenMnu: TMenuItem;
    ExecuteExplorerMnu: TMenuItem;
    OptionsSyntaxMnu: TMenuItem;
    ViewMainFileMnu: TMenuItem;
    OpenGroupPopItem: TMenuItem;
    N18: TMenuItem;
    ClosePopItem: TMenuItem;
    OptionsPropertiesMnu: TMenuItem;
    OptionsOpenRecentMmu: TMenuItem;
    N19: TMenuItem;
    EditIndentBlockMnu: TMenuItem;
    EditUnindentBlockMnu: TMenuItem;
    Tabs: TTabControl;
    ViewShowClipMnu: TMenuItem;
    ViewScrollBarsMnu: TMenuItem;
    ViewStatusBarMnu: TMenuItem;
    ViewToolBarMnu: TMenuItem;
    ViewTabsMnu: TMenuItem;
    OptionsFiltersMnuItem: TMenuItem;
    ClipboardMnu: TMenuItem;
    ClipboardDualMnu: TMenuItem;
    ClipboardStackMnu: TMenuItem;
    ClipboardQueueMnu: TMenuItem;
    N9: TMenuItem;
    ClipboardSwapClipMnu: TMenuItem;
    EditChangeCaseMnu: TMenuItem;
    EditChangeCaseLowerMnu: TMenuItem;
    EditChangeCaseUpperMnu: TMenuItem;
    EditChangeCaseTitleMnu: TMenuItem;
    EditSelectAllMnu: TMenuItem;
    EditInsertMnu: TMenuItem;
    EditInsertTimeMnu: TMenuItem;
    EditInsertDateMnu: TMenuItem;
    EditInsertTimeAndDateMnu: TMenuItem;
    EditIndentTabMnu: TMenuItem;
    FileRecycleMnu: TMenuItem;
    FileOpenParentMnu: TMenuItem;
    FileSaveParentMnu: TMenuItem;
    Menus1: TMenuItem;
    EditChangeCaseToggleMnu: TMenuItem;
    procedure FileOpenMnuClick(Sender: TObject);
    procedure FileSaveMnuClick(Sender: TObject);
    procedure FileSaveAsMnuClick(Sender: TObject);
    procedure FileExitMnuClick(Sender: TObject);
    procedure SearchFindMnuClick(Sender: TObject);
    procedure SearchReplaceMnuClick(Sender: TObject);
    procedure FilePrintMnuClick(Sender: TObject);
    procedure OptionsFontMnuClick(Sender: TObject);
    procedure OptionsEnvironmentMnuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileNewMnuClick(Sender: TObject);
    procedure EditSelectAllMnuClick(Sender: TObject);
    procedure EditCutMnuClick(Sender: TObject);
    procedure EditCopyMnuClick(Sender: TObject);
    procedure EditPasteMnuClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SearchSearchAgainMnuClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FileSaveAllMnuClick(Sender: TObject);
    procedure EditDeleteMnuClick(Sender: TObject);
    procedure ViewNextMnuClick(Sender: TObject);
    procedure ViewPreviousMnuClick(Sender: TObject);
    procedure SearchGotoLineNumberMnuClick(Sender: TObject);
    procedure WrapMnuClick(Sender: TObject);
    procedure EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OptionsRunMnuClick(Sender: TObject);
    procedure EditUndoMnuClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FilePrintSetupMnuClick(Sender: TObject);
    procedure EditMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExecuteDOSPromptMnuClick(Sender: TObject);
    procedure OptionsExecuteMnuClick(Sender: TObject);
    procedure ExecuteCurrentFileMnuClick(Sender: TObject);
    procedure FileReloadMnuClick(Sender: TObject);
    procedure EditDeleteLineMnuClick(Sender: TObject);
    procedure ExecuteDOSComMnuClick(Sender: TObject);
    procedure OptionsReadOnlyMnuClick(Sender: TObject);
    procedure HelpAboutMnuClick(Sender: TObject);
    procedure EditMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure EditCutLineMnuClick(Sender: TObject);
    procedure FileMnuClick(Sender: TObject);
    procedure OptionsOpenGroupMenuClick(Sender: TObject);
    procedure FileCloseGroupMnuClick(Sender: TObject);
    procedure FileCopyMnuClick(Sender: TObject);
    procedure FileMoveMnuClick(Sender: TObject);
    procedure FileRenameMnuClick(Sender: TObject);
    procedure FileDeleteMnuClick(Sender: TObject);
    procedure OptionsOpenFavoritesMnuClick(Sender: TObject);
    procedure HelpContentsMnuClick(Sender: TObject);
    procedure OptionsHintsMnuClick(Sender: TObject);
    procedure ViewSelectFileMnuClick(Sender: TObject);
    procedure FileBackupMnuClick(Sender: TObject);
    procedure FileBackupCurrentFileMnuClick(Sender: TObject);
    procedure FileBackupAllFilesMnuClick(Sender: TObject);
    procedure FileCloseCurrentFileMnuClick(Sender: TObject);
    procedure FileCloseAllFilesMnuClick(Sender: TObject);
    procedure FileInsertMnuClick(Sender: TObject);
    procedure FileUnbackupCurrentFileMnuClick(Sender: TObject);
    procedure FileUnbackupAllFilesMnuClick(Sender: TObject);
    procedure FileReplaceCurrentFileMnuClick(Sender: TObject);
    procedure FileReplaceAllFilesMnuClick(Sender: TObject);
    procedure FileSelectionSaveMnuClick(Sender: TObject);
    procedure FileSelectionOpenMnuClick(Sender: TObject);
    procedure ExecuteExplorerMnuClick(Sender: TObject);
    procedure OptionsSyntaxMnuClick(Sender: TObject);
    procedure ViewMainFileMnuClick(Sender: TObject);
    procedure AddFavoritesMnuClick(Sender: TObject);
    procedure PopupMenuPopup(Sender: TObject);
    procedure OptionsPropertiesMnuClick(Sender: TObject);
    procedure OptionsOpenRecentMmuClick(Sender: TObject);
    procedure EditIndentBlockMnuClick(Sender: TObject);
    procedure EditUnindentBlockMnuClick(Sender: TObject);
    procedure TabsChanging(Sender: TObject; var AllowChange: Boolean);
    procedure TabsChange(Sender: TObject);
    procedure ViewShowClipMnuClick(Sender: TObject);
    procedure ViewScrollBarsMnuClick(Sender: TObject);
    procedure ViewStatusBarMnuClick(Sender: TObject);
    procedure ViewToolBarMnuClick(Sender: TObject);
    procedure ViewTabsMnuClick(Sender: TObject);
    procedure AddGroupMnuClick(Sender: TObject);
    procedure OptionsFiltersMnuItemClick(Sender: TObject);
    procedure ClipboardDualMnuClick(Sender: TObject);
    procedure ClipboardStackMnuClick(Sender: TObject);
    procedure ClipboardQueueMnuClick(Sender: TObject);
    procedure ClipboardSwapClipMnuClick(Sender: TObject);
    procedure EditChangeCaseLowerMnuClick(Sender: TObject);
    procedure EditChangeCaseUpperMnuClick(Sender: TObject);
    procedure EditChangeCaseTitleMnuClick(Sender: TObject);
    procedure EditChangeCaseToggleMnuClick(Sender: TObject);
    procedure EditMnuClick(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure EditSelectionChange(Sender: TObject);
    procedure EditInsertTimeMnuClick(Sender: TObject);
    procedure EditInsertDateMnuClick(Sender: TObject);
    procedure EditInsertTimeAndDateMnuClick(Sender: TObject);
    procedure FileUnbackupMnuClick(Sender: TObject);
    procedure FileReplaceMnuClick(Sender: TObject);
    procedure EditIndentTabMnuClick(Sender: TObject);
    procedure FileRecycleMnuClick(Sender: TObject);
  private
    { Private declarations }
    WinNum : TFileNum;
    LastSelLength, LastStart : integer;
    EnterDown, DoCBtoPanel : boolean;
    indent : string;
    SelStartOffset : integer;
    Clips : TStringList;
    {must be 0 to color code; integer is used intead of
     boolean so pauses can be nested}
    PauseColorCoding : integer;
    hMod : boolean;//for Load/SaveAllEditAttributes
    AttribCount : integer;//for Load/SaveAllEditAttributes
    hHSP, hVSP, hSS, hSL : integer;//for Load/SaveEditAttributes
    AllAttribCount : integer;//for Load/SaveEditAttributes
    PrevTabIndex : integer;
    //used as function from Tabs.TabIndex to ith File
    TabFiles : array[0..MAX_FILE_NUM] of TFileNum;
    SelectionStatus : TSelectionStatus;
    FileTimesNames : TStringList;
    FileTimes : TList;

    //for propoerties
    FFileName : TFileName;
    FInsert : boolean;
    FClipType : byte;

    function FindFileIndex(const fName : TFileName) : integer;
    function ReloadFile(const fName : TFileName) : boolean;
    procedure LoadDefaultsIni;
    procedure SetFileName (const s : TFileName);
    procedure SetInsert (b : boolean);
    procedure SetClipType (i : byte);
    procedure SetRedraw(value : boolean);

    property Insert : boolean
      read FInsert
      write SetInsert;

    property ClipType : byte
      read FClipType
      write SetClipType;

    property RedrawOn : boolean
      write SetRedraw;

    procedure IndentWith(ch : char);
    procedure SetEditTabStops(tabSize : integer);
    function GetEditHorzScrollPos : integer;
    procedure SetEditHorzScrollPos(hsp : integer);
    function GetEditVertScrollPos : integer;
    procedure SetEditVertScrollPos(vsp : integer);
    function HasEditHorzScrollPosChanged : boolean;
    procedure InsertAtPos(const insertText : string; pos : integer);
    function GetFilter : string;
    procedure SetFilter(const f : string);
    function GetDefaultExt : TFileName;
    procedure SetDefaultExt(const ext : TFileName);
    procedure ChangeCaseWith(CaseChanger : TFCstringstring);
    procedure LoadEditAttributes;
    procedure SaveEditAttributes;
    function ColorCodingAvaliable : boolean;
    procedure InvalidateChars(pos : integer);
    procedure InvalidateLines(start, stop : integer);
    procedure ColorCodeWord(caretPos : integer);
    procedure ColorCodeFromStringList(strList : TStringList);
    procedure LoadAndColorCode(const fName : TFileName);
    procedure AssignAndColorCode(const str : string);
    procedure AddActiveTab (const fName : TFileName);
    procedure AddTab (const fName : TFileName; i : TFileNum);
    procedure LeftShiftTabFilesAt (i : integer);
    function InvTabFiles (i : TFileNum) : integer;
    function ClickTab (Sender : TObject; i : integer) : boolean;
    function GetCaretPos : TPoint;
    procedure EmailTitleToClip;
    procedure AutoIndentCurLine;
    function GetIndent (lineNo : integer) : string;
    procedure ChangeModify (b : boolean);
    procedure WriteModified;
    procedure OnAppRestore(Sender : TObject);
    procedure OnAppActivate (Sender : TObject);
    procedure OnAppDeactivate (Sender : TObject);
    procedure EnableMenus (b : boolean);
    function EditToAry : boolean;
    function AryToEdit : boolean;
    procedure SaveOptions;
    procedure EnableView;
    function CloseCurFile : boolean;
    procedure CloseCurFileOnError;
    procedure SetWrap (b : boolean);
    procedure EnableCutCopy;
    procedure SaveCurFile;
    procedure WriteCursPos;
    procedure ChangeColor;
    procedure ChangeReadOnly (b : boolean);
    function OpenParam : integer;
    procedure SetScrollBars;
    function CanOpen (const fName : TFileName; showMsg : boolean) : TCanOpen;
    //function FileTooBig (fName : TFileName): boolean;
    function AnyModified : boolean;
    procedure AddRecentNums;
    procedure DeleteRecentNums;
    function IsOpen (const fName : TFileName) : boolean;
    function CanAddToRecent (const fName : TFileName) : boolean;
    function RemoveFromRecent (const fName : TFileName) : boolean;
    function RecentPos (const fName : TFileName) : integer;
    function RemoveFromGroup (const fName : TFileName) : boolean;
    function RemoveFromFav (const fName : TFileName) : boolean;
    function AddToGroup (const fName : TFileName; askUser : boolean) : boolean;
    function InFav (const fName : TFileName) : SmallInt;
    procedure ShowStatusBar (b : boolean);
    function GetBackupName (const fName : TFileName) : TFileName;
    function IsOptionsFile (const fName : TFileName; showMsg : boolean) : boolean;
    //procedure ShowUnregMsg;
    procedure SelectionToFile (const fName : TFileName);
    function GetMainFile : string;
    procedure EditCut;
    procedure EditCopy;
    procedure EditPaste;
    procedure CBtoPanel;
    procedure ShowTabs (b : boolean);

  public
    { Public declarations }
    FindText : string;
    ColorScheme : TColorScheme;
    CustomFore, CustomBack : TColor;
    KeyMap : TKeyMap;
    FilesOpen, UntitledCount : byte;
    EndFindPosition, FindPosition : cardinal;
    NumOfRecs, StartWith : byte;
    Progs : array[1..MAX_REC_NUM] of ^TProg;
    ExeOpts : TExeOpts;
    groups : array[1..MaxMenuRows] of ^TStringList;
    MainFile : array[1..MaxMenuRows] of integer;
    GroupOpen : byte;
    Files : array[1..MAX_FILE_NUM - 1] of ^TFile;//1 in Edit
    BackupExt : TBackupExt;
    CanOpenOptions, SortViewFiles : boolean;
    ConfirmPrompt, PersistentGroups : boolean;
    AutoIndent : boolean;
    MaxRecentNum : Cardinal;
    TabUse : TTabUse;
    LangWordsList : TLangReservedWordsList;
    ColorCodingOn : boolean;
    TextDefaults : TTextDefaults;
    SearchedFiles : TStringList;

    property TabStops : integer
      write SetEditTabStops;

    property Filter : string
      read GetFilter
      write SetFilter;

    property DefaultExt : TFileName
      read GetDefaultExt
      write SetDefaultExt;

    property FileName : TFileName
      read FFileName
      write SetFileName;

    property EditHorzScrollPos : integer
      read GetEditHorzScrollPos
      write SetEditHorzScrollPos;

    property EditVertScrollPos : integer
      read GetEditVertScrollPos
      write SetEditVertScrollPos;

    function AnyFileNameOpenedTwice : boolean;
    function GetCommonPath : string;
    procedure CreateDefaultsIni;
    procedure LoadAllEditAttributes;
    procedure SaveAllEditAttributes;
    function ClickTabFile (Sender : TObject; i : TFileNum) : boolean;
    procedure ColorCodeLines(start, stop : integer; DoInvalidate : boolean);
    procedure ColorCodeAll;
    function AddToRecent (const fName : TFileName; check : boolean) : boolean;
    procedure CreatePopUpMenu;
    procedure ChangeKeyMap (inKeyMap : TKeyMap);
    function NewFile(fName : TFileName; allowDefaultCode : boolean) : boolean;
    function NextUntitledName : TFileName;
    function SaveChanges (i : byte; gotoFile : boolean) : word;
    procedure ShowEdit;
    function Search (const Options : TSearchTypes; findInFiles : boolean): boolean;
    procedure SwapEditAry (i : TFileNum);
    procedure AssignColorScheme (cs : TColorScheme);
    procedure ShowToolBar (b : boolean);
    function ChangeGroupFile (const f1, f2 : TFileName) : boolean;
    function OpenFileBack (const fName : TFileName; showMsg, openActive : boolean) : TCanOpen;
    function OpenFile (const fName : TFileName; showMsg : boolean) : TCanOpen;
    function AddToFav (const fName : TFileName) : boolean;
    function ChangeFavFile (const OldName, NewName : TFileName) : boolean;
    function ChangeRecentFile (const OldName, NewName : TFileName) : boolean;
    function CloseAllFiles : boolean;
    function IntToBackupExt (i : integer) : TBackupExt;
    function CanAddTo (const fName : TFileName) : boolean;
    function CloseOpenGroup : boolean;
    function InCurGroup (const fName : TFileName) : boolean;
    function GetCaretY : cardinal;
    procedure ShowFoundDlg (FoundOne : boolean);
    function ExpandParams (var Params : string) : boolean;
  end;

var
  MainForm: TMainForm;

implementation

uses AboutUnit, ReplaceUnit, RunUnit, HintUnit,
     EnvironmentUnit, ExecuteOptionsUnit,
     FindUnit, GroupUnit, CMUnit, FavUnit, ViewUnit,
     PropertiesUnit, RecentUnit, FiltersUnit,
     SyntaxHighlightingUnit, NewUnit, SaveModifiedUnit;

{$R *.DFM}

procedure TMainForm.OnAppRestore(Sender : TObject);
begin
  //if the application is minimized then restored,
  //Application.OnActivate will not be called
  OnAppActivate(Sender);
end;

procedure TMainForm.OnAppActivate (Sender : TObject);
var i, time : integer;
begin
  //will get called when the application is minimized
  //without this
  if not Active then exit;

  assert(FileTimesNames.Count = FileTimes.Count);

  if FileTimes.Count > 0 then
    for i := 0 to FileTimes.Count - 1 do
      if not GetFileTime(FileTimesNames[i], time) or (time <> integer(FileTimes[i]^)) then
        if MessageDlg(FileTimesNames[i] + ' has been modified outside of ' + EditorName + '. Reload?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          ReloadFile(FileTimesNames[i]);

  FileTimesNames.Clear;
  FileTimes.Clear;

  CBtoPanel;
  FixColor;
end;

procedure TMainForm.OnAppDeactivate (Sender : TObject);
var i, time : integer;
begin
  assert(FileTimes.Count = 0);
  assert(FileTimesNames.Count = 0);

  if FilesOpen > 0 then begin
    if GetFileTime(FileName, time) then begin
      FileTimesNames.Add(FileName);
      FileTimes.Add(newInteger(time));
    end;

    if FilesOpen > 1 then
      for i := 1 to FilesOpen - 1 do
        if GetFileTime(Files[i]^.FileName, time) then begin
          FileTimesNames.Add(Files[i]^.FileName);
          FileTimes.Add(newInteger(time));
        end;
  end;

  FixColor;
end;

//returns -1 if fName is not opened, 0 if fName = FileName,
//and the index of fName in Files otherwise
function TMainForm.FindFileIndex(const fName : TFileName) : integer;
begin
  if FilesOpen = 0 then begin
    result := -1;
    exit;
  end;

  if fName = FileName then begin
    result := 0;
    exit;
  end;

  if FilesOpen > 1 then
    for result := 1 to FilesOpen - 1 do
      if Files[result]^.FileName = fName then exit;

  result := -1;
end;

function TMainForm.ReloadFile(const fName : TFileName) : boolean;
var i : integer;
begin
  i := FindFileIndex(fName);
  result := (i <> -1) and (CanOpen(fName, false) = coTrue);
  if not result then exit;

  if i = 0 then
    LoadAndColorCode(FileName)//changes modify to false
  else begin
    Files[i]^.Text := FileToStr(fName);
    Files[i]^.Modified := false;
  end;
end;

procedure TMainForm.IndentWith(ch : char);
var
  i, start, stop : Integer;
  str : TStringList;
begin
  with Edit do begin
    {ReadOnly files shouldn't be able to be modified like
     this, but the code here would modify it anyway}
    if ReadOnly then exit;

    start := Perform (EM_LINEFROMCHAR, -1, 0);
    stop := Perform (EM_LINEFROMCHAR, SelStart + SelLength - 1, 0);
    {if SelLength = 0, then stop = start - 1 which keeps
     the for loop below from executing once like I want}
    if stop < start then stop := start;

    SaveEditAttributes;

    {the work is done in str to make the process look
     smoother}
    str := TStringList.Create;
    for i := start to stop do
      str.Add (ch + Lines[i]);

    RedrawOn := false;
    //Clear so changes to Text wasn't cause color coding
    if ColorCodingAvaliable then SelectionStatus.Clear;
    {select region starting at the begining of 1st
     indented line to beginning of the line after the
     last indented line; that's actually 1 extra char, so
     I don't need a "+ 1" in SelLength's assignment}
    SelStart := Perform (EM_LINEINDEX, start, 0);
    if stop + 1 >= Edit.Lines.Count then
      SelLength := GetTextLen - SelStart
    else
      SelLength := Perform (EM_LINEINDEX, stop + 1, 0) - SelStart - 2;
    inc(PauseColorCoding);
    SelText := copy(str.Text, 1, length(str.Text) - 2);
    dec(PauseColorCoding);
    str.Free;

    LoadEditAttributes;
    if SelLength = 0 then begin
      assert(start = stop);
      {InvalidateLines is called after RedrawOn so the
       line will be invalidated when color coding is off}
      ColorCodeLines(start, stop, false);
      RedrawOn := true;
      InvalidateLines(start, stop);
    end else begin
      SelLength := SelLength + stop - start + 1;
      RedrawOn := true;
      InvalidateLines(start, stop);
      if ColorCodingAvaliable then
        SelectionStatus.SetWithLines(start, stop);
    end;
  end;//with
  WriteModified;
end;

procedure TMainForm.SetEditTabStops(tabSize : integer);
var
  pf : TParaFormat;
  i, spaceWidth : integer;
  canvas : TControlCanvas;
begin
  pf.cbSize := sizeof(pf);
  pf.dwMask := PFM_TABSTOPS;
  pf.cTabCount := MAX_TAB_STOPS;

  canvas := TControlCanvas.Create;
  canvas.Control := Edit;
  canvas.Font := Edit.Font;
  spaceWidth := canvas.TextWidth(' ');
  canvas.Free;

  for i := 0 to MAX_TAB_STOPS - 1 do
    pf.rgxTabs[i] := (i + 1) * spaceWidth * tabSize * 1440 div Screen.PixelsPerInch;

  SetRedraw(false);
  SaveEditAttributes();
  //the whole thing must be selected for this to take effect
  Edit.SelectAll();
  Edit.Perform(EM_SETPARAFORMAT, 0, LPARAM(@pf));
  LoadEditAttributes();
  SetRedraw(true);
  Invalidate();
end;

function TMainForm.GetEditHorzScrollPos : integer;
begin
  result := GetScrollPos(Edit.handle, SB_HORZ);
end;

procedure TMainForm.SetEditHorzScrollPos(hsp : integer);
begin
  //SetScrollPos(Edit.handle, SB_HORZ, hsp, true);
  Edit.Perform(WM_HSCROLL, SB_THUMBPOSITION or (hsp shl 16), 0);
end;

function TMainForm.GetEditVertScrollPos : integer;
begin
  result := GetScrollPos(Edit.handle, SB_VERT);
end;

procedure TMainForm.SetEditVertScrollPos(vsp : integer);
begin
  //SetScrollPos(Edit.handle, SB_VERT, vsp, true);
  Edit.Perform(WM_VSCROLL, SB_THUMBPOSITION or (vsp shl 16), 0);
end;

function TMainForm.HasEditHorzScrollPosChanged : boolean;
begin
  result := hHSP <> EditHorzScrollPos;
end;

procedure TMainForm.LoadDefaultsIni;
var
  FileVar : TextFile;
  inStr : string;
begin
  if not FileExists(SourceDir + FN_DEFAULTS_INI) then exit;
  AssignFile(FileVar, SourceDir + FN_DEFAULTS_INI);
  Reset(FileVar);
    ReadLn(FileVar, inStr);
    Filter := inStr;
    LangWordsList.LoadFromFile(FileVar);
    TextDefaults.LoadFromFile(FileVar);
  CloseFile(FileVar);
end;

function TMainForm.AnyFileNameOpenedTwice : boolean;
var
  i : integer;
  FileNameList : TStringList;
  fName : string;
begin
  if FilesOpen <= 1 then begin
    result := false;
    exit;
  end;

  FileNameList := TStringList.Create;
  with FileNameList do begin
    Add(ExtractFileName(FileName));
    for i := 1 to FilesOpen - 2 do begin
      fName := ExtractFileName(Files[i]^.FileName);
      if IndexOf(fName) <> -1 then begin
        result := true;
        exit;
      end;

      Add(fName);
    end;
    result := IndexOf(ExtractFileName(Files[FilesOpen - 1]^.FileName)) <> -1;
    Free;
  end;
end;

function TMainForm.GetCommonPath : string;
var i : integer;
begin
  if FilesOpen = 0 then exit;
  result := ExtractFilePath(FileName);
  for i := 1 to FilesOpen - 1 do begin
    result := CommonPart(result, ExtractFilePath(Files[i]^.FileName), false);
    if result = '' then exit;
  end;
end;

procedure TMainForm.CreateDefaultsIni;
var FileVar : TextFile;
begin
  AssignFile(FileVar, SourceDir + FN_DEFAULTS_INI);
  Rewrite(FileVar);
    //WriteLn(FileVar, Filter);
    WriteLn(FileVar, 'Any File|*.*|html Files (html)|*.html|htm Files (htm)|*.htm|C++ Files (cpp)|*.cpp|C Files (c)|*.c|Header Files (h)|*.h|'+'Java Files (java)|*.java|Batch Files (bat)|*.bat|Assembly Files (asm)|*.asm|Pascal Files (pas)|*.pas|Basic Files (bas)|*.bas|Text Files (txt)|*.txt|Backup Files (bak)|*.bak|m3u Files (m3u)|*.m3u');
    LangWordsList.SaveToFile(FileVar);
    TextDefaults.SaveToFile(FileVar);
  CloseFile(FileVar);
end;

procedure TMainForm.InsertAtPos(const insertText : string; pos : integer);
var
  lineNo, lineStart : integer;
  newValue : string;
begin
  with Edit do begin
    SaveEditAttributes;
    lineNo := Perform(EM_LINEFROMCHAR, pos, 0);
    lineStart := Perform(EM_LINEINDEX, lineNo, 0);
    SelText := '';
    newValue := Lines[lineNo];
    System.Insert(insertText, newValue, pos - lineStart + 1);
    Lines[lineNo] := newValue;
    LoadEditAttributes;
    SelStart := SelStart + length(insertText);
    ColorCodeLines(lineNo, lineNo, true);
  end;
end;

function TMainForm.GetFilter : string;
begin
  result := OpenDlg.Filter;
end;

procedure TMainForm.SetFilter(const f : string);
begin
  OpenDlg.Filter := f;
  SaveDlg.Filter := f;
end;

function TMainForm.GetDefaultExt : TFileName;
begin
  result := OpenDlg.DefaultExt;
end;

procedure TMainForm.SetDefaultExt(const ext : TFileName);
begin
  OpenDlg.DefaultExt := ext;
  //SaveDlg.DefaultExt := ext;
end;

procedure TMainForm.SetRedraw(value : boolean);
const redrawCount : integer = 0;
begin
  if value then begin
    assert(redrawCount > 0);
    dec(redrawCount);
    //Don't want Edit to be redrawn if it's not visible
    if Edit.Visible and (redrawCount = 0) then
      Edit.Perform(WM_SETREDRAW, 1, 0);
  end else begin
    if redrawCount = 0 then begin
      //update before turning redraw off or the invalid
      //region will be lost
      Edit.Update;
      Edit.Perform(WM_SETREDRAW, 0, 0);
    end;
    inc(redrawCount);
  end;
end;

procedure TMainForm.ChangeCaseWith(CaseChanger : TFCstringstring);
var start, stop : integer;
begin
  with Edit do begin
    start := Perform(EM_LINEFROMCHAR, SelStart, 0);
    stop := Perform(EM_LINEFROMCHAR, SelStart + SelLength, 0);

    RedrawOn := false;
    SaveEditAttributes;
    if ColorCodingAvaliable then
      SelectionStatus.SetWithLines(start, stop);

    SelText := CaseChanger(Edit.SelText);

    LoadEditAttributes;
    RedrawOn := true;
    InvalidateLines(start, stop);
    WriteModified;
  end;
end;

procedure TMainForm.LoadEditAttributes;
begin
  dec(AttribCount);
  if AttribCount = 0 then
    with Edit do begin
      SelStart := hSS;
      SelLength := hSL;
      //EditFirstVisibleLine := hFVL;
      SetScrollPos(handle, SB_VERT, hVSP, false);
      SetScrollPos(handle, SB_HORZ, hHSP, false);
    end;
end;

procedure TMainForm.SaveEditAttributes;
begin
  if AttribCount = 0 then
    with Edit do begin
      hSS := SelStart;
      hSL := SelLength;
      //hFVL := EditFirstVisibleLine;
      hVSP := GetScrollPos(handle, SB_VERT);
      hHSP := GetScrollPos(handle, SB_HORZ);
    end;
  inc(AttribCount);
end;

procedure TMainForm.LoadAllEditAttributes;
begin
  dec(AllAttribCount);
  if AllAttribCount = 0 then begin
    LoadEditAttributes;
    Edit.Modified := hMod;
  end;
end;

procedure TMainForm.SaveAllEditAttributes;
begin
  if AllAttribCount = 0 then begin
    SaveEditAttributes;
    hMod := Edit.Modified;
  end;
  inc(AllAttribCount);
end;

function TMainForm.ColorCodingAvaliable : boolean;
begin
  result := ColorCodingOn and (LangWordsList.CurIndex <> -1);
end;

procedure TMainForm.ColorCodeFromStringList(strList : TStringList);

  function MakeColorTableEntry(color : TColor) : string;
  var
    long : LongInt;
    r, g, b : byte;
  begin
    long := ColorToRGB(color);
    r := long mod $100;
    long := long div $100;
    g := long mod $100;
    long := long div $100;
    b := long mod $100;
    result := '\red' + IntToStr(r) + '\green' + IntToStr(g) + '\blue' + IntToStr(b) + ';';
  end;

  //in RTF the symbols {, }, and / are preceded by a /
  procedure FixRTFSymbols(var str : string);
  var i, len : integer;
  begin
    len := length(str);
    i := 1;
    while i <= len do begin
      if (str[i] = '{') or (str[i] = '}') or (str[i] = '\') then begin
        System.Insert('\', str, i);
        inc(len);
        inc(i);
      end;
      inc(i);
    end;
  end;

var
  i, j : integer;
  str1, str2 : string;
begin
  if (PauseColorCoding > 0) or
     not ColorCodingAvaliable then
    with Edit do begin
      RedrawOn := false;
      //to make new text the color of DefAttributes
      Text := ' ';
      SelStart := 0; SelLength := 1;
      SelAttributes := DefAttributes;

      SelLength := 0;
      RedrawOn := true;
      Text := strList.Text;
      ChangeModify(false);
      exit;
    end;

  if strList.Count > 0 then
    for j := 0 to strList.Count - 1 do
      with LangWordsList do
        with Parses do begin
          ParseLine(strList[j]);
          str1 := '';
          for i := 0 to Items.Count - 1 do begin
            case Items[i]^.Kind of
              tkPlainText : str1 := str1 + '\cf0 ';
              tkSymbol : str1 := str1 + '\cf1 ';
              tkKeyWord : str1 := str1 + '\cf2 ';
            end;
            str2 := copy(strList[j], Items[i].Start, Items[i].Length);
            FixRTFSymbols(str2);
            str1 := str1 + str2;
          end;

          if j > 0 then str1 := '\par ' + str1;
          strList[j] := str1;
        end;

  strList.Insert(0, '{\rtf1\ansi\ansicpg1252\deff0\deftab720{\fonttbl{\f0\fmodern\fcharset1 ' + Edit.Font.Name + ';}}');
  {color table must contain colors for plain text, symbols,
   and key words IN THAT ORDER}
  strList.Insert(1, '{\colortbl' + MakeColorTableEntry(Edit.Font.Color) + MakeColorTableEntry(LangWordsList.SymbolsColor) + MakeColorTableEntry(LangWordsList.KeyWordsColor) + '}');
  strList.Insert(2, '\deflang1033\pard\plain\f0\fs' + IntToStr(2*Edit.Font.Size));

  //RTF files end with a }
  strList.Add('}');

  strList.SaveToFile(SourceDir + FN_TEMP_RTF);
  Edit.PlainText := false;
  inc(PauseColorCoding);
  Edit.Lines.LoadFromFile(SourceDir + FN_TEMP_RTF);
  //LoadFromFile fucks up the tabs stop, so SetEditTabStops
  //must be called to fix them
  TabStops := TabUse.TabSize;
  dec(PauseColorCoding);
  Edit.PlainText := true;
  Edit.Invalidate;
  ChangeModify(false);
end;

procedure TMainForm.LoadAndColorCode(const fName : TFileName);
var strList : TStringList;
begin
  strList := TStringList.Create;
  strList.LoadFromFile(fName);
  ColorCodeFromStringList(strList);
  strList.Free;
end;

procedure TMainForm.AssignAndColorCode(const str : string);
var strList : TStringList;
begin
  strList := TStringList.Create;
  strList.Text := str;
  ColorCodeFromStringList(strList);
  strList.Free;
end;

procedure TMainForm.AddActiveTab (const fName : TFileName);
begin
  //now TabFiles[Tabs.TabIndex] = 0
  if Tabs.Tabs.Count > 0 then
    TabFiles[Tabs.TabIndex] := FilesOpen;

  AddTab (fName, 0);
  Tabs.TabIndex := Tabs.Tabs.Count - 1;
end;

procedure TMainForm.AddTab (const fName : TFileName; i : TFileNum);
begin
  Tabs.Tabs.Add (StringToLabel (ExtractFileName (fName)));
  TabFiles[Tabs.Tabs.Count - 1] := i;
end;

procedure TMainForm.LeftShiftTabFilesAt (i : integer);
begin
  assert (i >= 0);

  if Tabs.Tabs.Count > 0 then
    for i := i to Tabs.Tabs.Count - 1 do
      TabFiles[i] := TabFiles[i + 1];
end;

{is a function that takes ith file number and returns
 the corresponding Tabs.TabIndex}
function TMainForm.InvTabFiles (i : TFileNum) : integer;
var j : integer;
begin
  if Tabs.Tabs.Count = 0 then begin
    result := -1;
    exit;
  end;

  for j := 0 to Tabs.Tabs.Count - 1 do
    if TabFiles[j] = i then begin
      result := j;
      exit;
    end;

  result := -1;
  //raise Exception.Create ('InvTabFiles: i has no index in TabFiles');
end;

//click on tab w/ TabIndex i
function TMainForm.ClickTab (Sender : TObject; i : integer) : boolean;
begin
  with Tabs do begin
    result := true;
    OnChanging (Sender, result);
    if not result then exit;

    TabIndex := i;
    OnChange (Sender);
  end;
end;

//clicks on tab cooresponding to ith file
function TMainForm.ClickTabFile (Sender : TObject; i : TFileNum) : boolean;
begin
  result := ClickTab (Sender, InvTabFiles (i));
end;

function TMainForm.GetCaretPos : TPoint;
begin
  if Edit.SelStart = LastStart then
    result.x := Edit.SelStart + Edit.SelLength
  else
    result.x := Edit.SelStart;

  result.y := Edit.Perform (EM_LINEFROMCHAR, result.x, 0);
  result.x := result.x - Edit.Perform (EM_LINEINDEX, result.y, 0);
end;

procedure TMainForm.EmailTitleToClip;
var
  i : integer;
  fName, clip : string;
  const from = 'From ';
  const subj = 'Subject: ';
  const subjStart = length (subj) + 1;
begin
  clip := Clipboard.AsText;
  i := pos(from, clip);
  if (i = 0) or (i > 3) then exit;

  FixColor;
  Edit.SelectAll;
  Edit.PasteFromClipboard;
  if (i > 1) then
     Edit.Lines.Delete(0);

  fName := Edit.Lines[0] + '[';
  for i := 1 to Edit.Lines.Count - 1 do
    if posi (subj, Edit.Lines[i]) > 0 then begin
      fName := fName + copy (Edit.Lines[i], subjStart, length (Edit.Lines[i]) - SubjStart);
      break;
    end;
  fName := fName + ']';

  ReplaceAll (':', ';', fName);
  ReplaceAll ('"', '''', fName);
  ReplaceAll ('\', ';', fName);
  ReplaceAll ('/', ';', fName);
  ReplaceAll ('?', '!', fName);
  ReplaceAll ('|', 'I', fName);
  ReplaceAll ('*', '[asterix]', fName);
  ReplaceAll ('>', ')', fName);
  FileName := SaveDlg.InitialDir + '\' + fName + '.txt';
  LangWordsList.UpdateCurItem(FileName);
  ColorCodeAll;
  CBtoPanel;
end;

{adds indention to current line so current line has
 the same indent as the line above it and moves the caret
 to just after the indention}
procedure TMainForm.AutoIndentCurLine;
var i : integer;
begin
  if indent = '' then exit;
  i := Edit.Perform (EM_LINEFROMCHAR, -1, 0);
  Edit.Lines[i] := indent + LTrim (Edit.Lines[i]);
  Edit.SelStart := Edit.Perform (EM_LINEINDEX, -1, 0) + SelStartOffset;
  ColorCodeLines(i, i, true);
end;

{returns a string containing the spaces and tabs line #
 lineNo is indented with}
function TMainForm.GetIndent (lineNo : integer) : string;
var i, len : integer;
begin
  //return empty string for invalid line
  if (lineNo < 0) or (lineNo >= Edit.Lines.Count) then exit;

  len := length (Edit.Lines[lineNo]);
  if len > 0 then
    for i := 1 to len do
      if (Edit.Lines[lineNo][i] = ' ') or (Edit.Lines[lineNo][i] = chr(VK_TAB)) then
        result := result + Edit.Lines[lineNo][i]
      else
        exit;
end;

function TMainForm.GetBackupName (const fName : TFileName) : TFileName;
begin
  if BackupExt = beBak then
    result := ChangeExt (fName, '.bak')
  else
    result := ExtractFilePath (fName) + '~' + ExtractFileName (fName);
end;

function TMainForm.IsOptionsFile (const fName : TFileName; showMsg : boolean) : boolean;
begin
  result := StrCmpi (fName, SourceDir + OptionsFileName);
  if result and showMsg then
    ShowMsgDlg (EditorName + ' cannot open "' + OptionsFileName + '"', mtWarning);
end;

{procedure TMainForm.ShowUnregMsg;
begin
    ShowMessage ('This program is unregsitered shareware and should be used for evaluation purposes only.  By registering it you will recieve benefits like:' + cr +
      '1. This annoying message will not be displayed ever time you run this program.' + cr +
      '2. Your name will be in the About box' + cr +
      '3. I will answer questions you have about Code Edit' + cr +
      '4. You will be supporting independent programming' + pb +
      'If you decide to keep ' + EditorName + ', please send $5.00 (five-dollars) U.S. in cash or check to:' + pb +
      'Jimmy Reumuth' + cr +
      '406 Eldon Dr.' + cr +
      'Corpus Christi, Tx 78412' + cr +
      'United States of America' + pb +
      'Please include an e-mail address (which will NOT be used for any commercial purposes) to expedite your registration, and so I''ll be able to send you new versions of Code Edit at no cost to you.');
end;}

//Saves the selected text to file fName
procedure TMainForm.SelectionToFile (const fName : TFileName);
var FileVar : TextFile;
begin
  AssignFile (FileVar, fName);
  Rewrite (FileVar);
    write (FileVar, Edit.SelText);
  CloseFile (FileVar);
end;

{returns the main file of the current group, if FileName
 is in the open group, and a main file has been
 specified}
function TMainForm.GetMainFile : string;
begin
  if InCurGroup (FileName) and (MainFile[GroupOpen] >= 0) then
    result := groups[GroupOpen]^.Strings[MainFile[GroupOpen]]
  else
    result := FileName;
end;

procedure TMainForm.CreatePopUpMenu;
begin
  CopyMenuItem (OpenGroupPopItem, FileOpenGroupMnu);
  CopyMenuItem (AddToPopItem, FileAddMnu);
  CopyMenuItem (ClosePopItem, FileCloseMnu);
end;

procedure TMainForm.EditCut;
begin
  if ClipType = CT_STACK then
    if Clipboard.AsText <> '' then
      Clips.Insert (0, Clipboard.AsText);

  if ClipType = CT_QUEUE then
    if Clipboard.AsText <> '' then begin
      Clips.Insert (0, Edit.SelText);
      Edit.SelText := '';
    end;

  if (ClipType <> CT_QUEUE) or (Clipboard.AsText = '') then begin
    Edit.CutToClipboard;
    CBtoPanel;
  end;

  EnableCutCopy;
  WriteModified;
  Edit.Repaint;
end;

procedure TMainForm.EditCopy;
begin
  if ClipType = CT_STACK then
    if Clipboard.AsText <> '' then
      Clips.Insert (0, Clipboard.AsText);

  if ClipType = CT_QUEUE then
    if Clipboard.AsText <> '' then
      Clips.Insert (0, Edit.SelText);

  if (ClipType <> CT_QUEUE) or (Clipboard.AsText = '') then begin
    Edit.CopyToClipboard;
    CBtoPanel;
  end;
end;

procedure TMainForm.EditPaste;
var i : integer;
begin
  Edit.PasteFromClipboard;

  //Color Code pasted in lines
  i := Edit.Perform(EM_LINEFROMCHAR, -1, 0);
  ColorCodeLines(i - GetCRCount(Clipboard.AsText), min(i, Edit.Lines.Count - 1), false);
  //all lines after i moved down so need repainting also
  Edit.Repaint;
  WriteModified;

  if Clips.Count > 0 then
    if ClipType = CT_STACK then begin
      Clipboard.AsText := Clips.Strings[0];
      Clips.Delete (0);
      CBtoPanel;
    end else if ClipType = CT_QUEUE then begin
      Clipboard.AsText := Clips.Strings[Clips.Count - 1];
      Clips.Delete (Clips.Count - 1);
      CBtoPanel;
    end;
end;

procedure TMainForm.CBtoPanel;
begin
  if ViewShowClipMnu.Checked then
    StatusBar1.Panels[PN_CLIP].Text := TabsToSpaces(Clipboard.AsText, TabUse.TabSize);
end;

function TMainForm.IntToBackupExt (i : integer) : TBackupExt;
begin
  if i = 0 then
    result := beBak
  else
    result := beTilde;
end;

function TMainForm.CanAddTo (const fName : TFileName) : boolean;
begin
  result := not IsOptionsFile (fName, true);
end;

procedure TMainForm.SwapEditAry (i : TFileNum);
var
  s : string;
  m : boolean;
  SelStart, SelLength : cardinal;
  hHSP, hVSP : integer;
begin
  assert ((i > 0) and (i < MAX_FILE_NUM), 'SwapEditAry');

  //SelStart used at temp var
  SelStart := TabFiles[Tabs.TabIndex];
  TabFiles[Tabs.TabIndex] := TabFiles[PrevTabIndex];
  TabFiles[PrevTabIndex] := SelStart;

  RedrawOn := false;

  s := FileName;
  FileName := Files[i]^.FileName;
  LangWordsList.UpdateCurItem(FileName);
  Files[i]^.FileName := s;

  SelLength := Edit.SelLength;
  SelStart := Edit.SelStart;
  m := Edit.Modified;
  //fvl := EditFirstVisibleLine;
  hVSP := EditVertScrollPos;
  hHSP := EditHorzScrollPos;

  s := Files[i]^.Text;
  Files[i]^.Text := Edit.Text;
  AssignAndColorCode(s);

  Edit.SelStart := Files[i]^.SelStart;
  Edit.SelLength := Files[i]^.SelLength;
  //EditFirstVisibleLine := Files[i]^.FirstVisibleLine;
  EditVertScrollPos := Files[i]^.VertScrollPos;
  EditHorzScrollPos := Files[i]^.HorzScrollPos;
  Files[i]^.SelLength := SelLength;
  Files[i]^.SelStart := SelStart;
  Files[i]^.VertScrollPos := hVSP;
  Files[i]^.HorzScrollPos := hHSP;
  //Files[i]^.FirstVisibleLine := fvl;

  ChangeModify (Files[i]^.Modified);
  Files[i]^.Modified := m;
  WriteModified;

  WriteCursPos;
  EnableCutCopy;

  m := Edit.ReadOnly;
  ChangeReadOnly (Files[i]^.ReadOnly);
  Files[i]^.ReadOnly := m;

  RedrawOn := true;
  Edit.Invalidate;
end;

function TMainForm.EditToAry : boolean;
begin
  if (FileName = '') or (FilesOpen = 0) then begin
    result := false;
    exit;
  end;

  New (Files[FilesOpen]);
  Files[FilesOpen]^.Text := Edit.Text;
  Files[FilesOpen]^.FileName := FileName;
  Files[FilesOpen]^.Modified := Edit.Modified;
  Files[FilesOpen]^.SelStart := Edit.SelStart;
  Files[FilesOpen]^.SelLength := Edit.SelLength;
  Files[FilesOpen]^.ReadOnly := Edit.ReadOnly;
  //Files[FilesOpen]^.FirstVisibleLine := EditFirstVisibleLine;
  Files[FilesOpen]^.VertScrollPos := EditVertScrollPos;
  Files[FilesOpen]^.HorzScrollPos := EditHorzScrollPos;

  result := true;
end;

function TMainForm.AryToEdit : boolean;
begin
  if FilesOpen < 1 then begin
    result := false;
    exit;
  end;

  if WinNum = FilesOpen then WinNum := 1;

  RedrawOn := false;

  ChangeReadOnly (Files[FilesOpen]^.ReadOnly);
  FileName := Files[FilesOpen]^.FileName;
  LangWordsList.UpdateCurItem(FileName);
  AssignAndColorCode(Files[FilesOpen]^.Text);
  Edit.SelStart := Files[FilesOpen]^.SelStart;
  Edit.SelLength := Files[FilesOpen]^.SelLength;
  //EditFirstVisibleLine := Files[FilesOpen]^.FirstVisibleLine;
  EditVertScrollPos := Files[FilesOpen]^.VertScrollPos;
  EditHorzScrollPos := Files[FilesOpen]^.HorzScrollPos;

  ChangeModify (Files[FilesOpen]^.Modified);

  Dispose (Files[FilesOpen]);

  WriteCursPos;

  RedrawOn := true;
  Edit.Repaint;

  result := true;
end;

procedure TMainForm.WriteModified;
var i : byte;
begin
  if not Edit.Visible then exit;
  EditUndoMnu.Enabled :=
    IntToBool (Edit.Perform (EM_CanUndo, 0, 0));
  UndoSpdBtn.Enabled := EditUndoMnu.Enabled;

  if Edit.Modified then begin
    StatusBar1.Panels[PN_MODIFIED].Text := 'Modified';
    FileSaveMnu.Enabled := true;
    SaveSpdBtn.Enabled := true;
    SaveAllSpdBtn.Enabled := true;
    FileSaveAllMnu.Enabled := true;
  end else begin
    StatusBar1.Panels[PN_MODIFIED].Text := '';
    FileSaveMnu.Enabled := false;
    SaveSpdBtn.Enabled := false;
    FileSaveAllMnu.Enabled := false;
    SaveAllSpdBtn.Enabled := false;
    if FilesOpen > 1 then
      for i := 1 to FilesOpen - 1 do
        if Files[i]^.Modified then begin
          FileSaveAllMnu.Enabled := true;
          SaveAllSpdBtn.Enabled := true;
          break;
        end;
  end;
end;

procedure TMainForm.ChangeModify (b : boolean);
begin
  if Edit.Modified = b then exit;
  Edit.Modified := b;
  WriteModified;
end;

procedure TMainForm.EnableMenus (b : boolean);
begin
  {Disables appropriate menus when all files
   are close and enables them again when at
   least one file is open}
  FileSaveMnu.Enabled := b;
  SaveSpdBtn.Enabled := b;
  FileSaveAllMnu.Enabled := b;
  SaveAllSpdBtn.Enabled := b;
  FileSaveAsMnu.Enabled := b;
  FileInsertMnu.Enabled := b;
  FilePrintMnu.Enabled := b;
  PrintSpdBtn.Enabled := b;
  FileBackupMnu.Enabled := b;
  FileUnbackupMnu.Enabled := b;
  FileReplaceMnu.Enabled := b;
  FileCloseMnu.Enabled := b;
  FileCloseCurrentFileMnu.Enabled := b;
  CloseSpdBtn.Enabled := b;
  FileCloseAllFilesMnu.Enabled := b;
  FileReloadMnu.Enabled := b;
  FileOperationsMnu.Enabled := b;
  FileAddMnu.Enabled := b;
  EditMnu.Enabled := b;
  CutSpdBtn.Enabled := b and EditCutMnu.Enabled;
  CopySpdBtn.Enabled := b and EditCopyMnu.Enabled;
  PasteSpdBtn.Enabled := b;
  SearchMnu.Enabled := b;
  FindSpdBtn.Enabled := b;
  SearchAgainSpdBtn.Enabled := b;
  ReplaceSpdBtn.Enabled := b;
  ExecuteCurrentFileMnu.Enabled := b and (ExeOpts.IndexOfSource (ExtractFileExt (FileName)) >= 0);
  ExecuteSpdBtn.Enabled := ExecuteCurrentFileMnu.Enabled;
  ViewMainFileMnu.Enabled := (GroupOpen > 0) and
    (MainFile[GroupOpen] >= 0);

  UndoSpdBtn.Enabled := b;
  OptionsPropertiesMnu.Enabled := b;

  if b then begin
    WriteModified;
    WriteCursPos;
    Insert := Insert;//calls SetInsert
  end else begin
    StatusBar1.Panels[PN_POS].Text := '';
    StatusBar1.Panels[PN_MODIFIED].Text := '';
    StatusBar1.Panels[PN_INSERT].Text := '';
  end;
end;

procedure TMainForm.ShowEdit;
begin
  Edit.Show;
  ActiveControl := Edit;
  EnableMenus (true);
end;

function TMainForm.NewFile(fName : TFileName; allowDefaultCode : boolean) : boolean;
begin
  if FilesOpen = MAX_FILE_NUM then begin
    ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    result := false;
    exit;
  end;

  if Edit.Visible then begin
    if FilesOpen > 0 then EditToAry;
  end else
    ShowEdit;

  AddActiveTab (FileName);
  FileName := fName;
  LangWordsList.UpdateCurItem(FileName);

  inc (FilesOpen);

  if IsUntitled(FileName) then inc (UntitledCount);

  if allowDefaultCode then
    AssignAndColorCode(TextDefaults.GetText(ExtractFileExt(FileName)))
  else
    Edit.Clear;

  ChangeReadOnly (false);
  ChangeModify(false);
  EnableView;
  WriteModified;
  result := true;
end;

function TMainForm.NextUntitledName : TFileName;
begin
  result := ChangeExt (UNTITLED_PREFIX + IntToStr (UntitledCount), DefaultExt);
end;

procedure TMainForm.ChangeKeyMap (inKeyMap : TKeyMap);
begin
  KeyMap := inKeyMap;
  case KeyMap of
    kmWindows : begin
      FileSaveMnu.ShortCut := TextToShortCut ('Ctrl+S');
      FileOpenMnu.ShortCut := TextToShortCut ('Ctrl+O');
      SearchSearchAgainMnu.ShortCut := TextToShortCut ('F3');
      FileCloseCurrentFileMnu.ShortCut := TextToShortCut ('Ctrl+F4');
      FileExitMnu.ShortCut := TextToShortCut ('Alt+F4');
      EditUndoMnu.ShortCut := TextToShortCut ('Ctrl+Z');
      ViewSelectFileMnu.ShortCut := TextToShortCut ('F2');
    end;

    kmPascal : begin
      FileSaveMnu.ShortCut := TextToShortCut ('F2');
      FileOpenMnu.ShortCut := TextToShortCut ('F3');
      SearchSearchAgainMnu.ShortCut := TextToShortCut ('Ctrl+L');
      FileCloseCurrentFileMnu.ShortCut := TextToShortCut ('Alt+F3');
      FileExitMnu.ShortCut := TextToShortCut ('Alt+X');
      EditUndoMnu.ShortCut := TextToShortCut ('Alt+BkSp');
      ViewSelectFileMnu.ShortCut := TextToShortCut ('Alt+0');
    end;
  end;
end;

procedure TMainForm.AssignColorScheme (cs : TColorScheme);
begin
  ColorScheme := cs;
  ChangeColor;
end;

procedure TMainForm.ChangeColor;
var oldFore, oldBack : TColor;
begin
  oldFore := Edit.Font.Color;
  oldBack := Edit.Color;

  case ColorScheme of
    csWindows : begin
      Edit.Font.Color := clWindowText;
      Edit.Color := clWindow;
    end;

    csPascal : begin
      Edit.Font.Color := clYellow;
      Edit.Color := clNavy;
    end;

    csCustom : begin
      Edit.Font.Color := CustomFore;
      Edit.Color := CustomBack;
    end;
  end;

  if (oldFore <> Edit.Font.Color) or (oldBack <> Edit.Color) then
    ColorCodeAll;
end;

procedure TMainForm.SetFileName (const s : TFileName);
begin
  FFileName := s;
  if FileName = '' then begin
    MainForm.Caption := EditorName;
    Edit.Hide;
    EnableMenus (false);
  end else begin
    if InCurGroup (FileName) then
      MainForm.Caption := EditorName +
        ' - [' + CapToStr (FileOpenGroupMnu.Items[GroupOpen - 1].Caption) + '] ' + FileName
    else
      MainForm.Caption := EditorName +
        ' - ' + FileName;

    ExecuteCurrentFileMnu.Enabled := ExeOpts.IndexOfSource (ExtractFileExt (FileName)) >= 0;
    ExecuteSpdBtn.Enabled := ExecuteCurrentFileMnu.Enabled;
  end;

  if Tabs.TabIndex > -1 then
    Tabs.Tabs[Tabs.TabIndex] := StringToLabel (ExtractFileName (FileName));

  Application.Title := MainForm.Caption;
end;

function TMainForm.OpenFile (const fName : TFileName; showMsg : boolean) : TCanOpen;
var hCursor : integer;
begin
  result := CanOpen (fName, showMsg);

  if result <> coTrue then exit;

  if Edit.Visible then
    EditToAry
  else
    ShowEdit;

  AddActiveTab (fName);

  FileName := fName;
  LangWordsList.UpdateCurItem(FileName);
  inc (FilesOpen);

  try
    hCursor := Edit.Cursor;
    Edit.Cursor := crHourGlass;
    LoadAndColorCode(fName);
    Edit.Cursor := hCursor;
  except
    on Exception do begin
      CloseCurFileOnError;
      raise Exception.Create ('Could not open file "' + fName + '"');
    end;
  end;

  Edit.SelStart := 0;
  ChangeReadOnly (IsReadOnly (fName));

  {RichEdits dont't change modified property
   to false after loading from file}
  ChangeModify (false);
  EnableView;
end;

{this function opens fName directly into Files instead of
 into Edit; used at beginning if last files open are
 loaded so all files are not shown being opened and
 also used when a group is opened; if openActive then
 OpenFile is called instead of OpenFileBack}
function TMainForm.OpenFileBack (const fName : TFileName; showMsg, openActive : boolean) : TCanOpen;
begin
  //if openActive then use OpenFile instead of OpenFileBack
  if openActive then begin
    result := OpenFile (fName, showMsg);
    exit;
  end;

  result := CanOpen (fName, showMsg);

  if result <> coTrue then exit;

  Edit.Cursor := crHourGlass;
  AddTab (fName, FilesOpen);

  //FilesOpen is inc in last line if not done here
  if FileName = '' then inc (FilesOpen);

  New (Files[FilesOpen]);
  Files[FilesOpen]^.Text := FileToStr (fName);
  Files[FilesOpen]^.Modified := false;
  Files[FilesOpen]^.FileName := fName;

  //these three are default value which may be overwritten
  Files[FilesOpen]^.ReadOnly := false;
  Files[FilesOpen]^.SelStart := 0;
  Files[FilesOpen]^.SelLength := 0;
  //Files[FilesOpen]^.FirstVisibleLine := 0;
  Files[FilesOpen]^.VertScrollPos := 0;
  Files[FilesOpen]^.HorzScrollPos := 0;

  if FileName <> '' then inc (FilesOpen);

  Edit.Cursor := crDefault;
  EnableView;
end;

procedure TMainForm.FileOpenMnuClick(Sender: TObject);
var i, count : integer;
begin
  if FilesOpen = MAX_FILE_NUM then begin
    ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    exit;
  end;

  OpenDlg.FilterIndex := GetFilterItemIndex ('*' + ExtractFileExt (FileName), Filter);

  if not OpenDlg.execute then exit;
  count := OpenDlg.Files.Count;
  if count = 0 then exit;

  for i := count - 1 downto 0 do begin
    if FilesOpen = MAX_FILE_NUM then begin
      ShowMsgDlg ('No more Files can be Opened!', mtWarning);
      break;//still set initial directory
    end;

    OpenFileBack(OpenDlg.Files[i], true, i = count - 1);
    if ofReadOnly in OpenDlg.Options then
      if i = count - 1 then
        ChangeReadOnly(true)
      else
        Files[FilesOpen-1]^.ReadOnly := true;
  end;

  OpenDlg.InitialDir := ExtractFilePath (FileName);
//  if not FileExists (OpenDlg.FileName) then begin
//    if ofCreatePrompt in OpenDlg.Options then begin
      {if execute and not FileExists then the
      user must have Yesed a Create Prompt}
//      NewFile(OpenDlg.FileName, true);
//    end else
//      ShowMsgDlg (OpenDlg.FileName + ' does not exist', mtWarning);
//  end else if OpenFile (OpenDlg.FileName, true) <> coTrue then exit;

//  OpenDlg.InitialDir := ExtractFilePath (FileName);

//  if ofReadOnly in OpenDlg.Options then
//    ChangeReadOnly (true);
end;

function TMainForm.CanOpen (const fName : TFileName; showMsg : boolean) : TCanOpen;
begin
  if not FileExistsEx(fName, true) then begin
    if showMsg then ShowMsgDlg ('File "' + fName + '" cannot be found', mtWarning);
    result := coNotExists;
    exit;
  end;

  if not CanOpenOptions and IsOptionsFile (fName, showMsg) then begin
    CanOpenOptions := false;
    result := coOptionsFile;
    exit;
  end;

  if FilesOpen = MAX_FILE_NUM then begin
    if showMsg then ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    result := coMaxFiles;
    exit;
  end;

  result := coTrue;
end;

procedure TMainForm.FileSaveMnuClick(Sender: TObject);
begin
  if not FileExistsEx(FileName, true) then
    FileSaveAsMnu.Click
  else
    SaveCurFile;
end;

procedure TMainForm.SaveCurFile;
begin
  if IsReadOnly (FileName) then begin
    raise EWriteError.Create ('This is a readonly file.  If you want to save this file, use a different name or make it non-readonly.');
    exit;
  end;

  try
    Edit.Lines.SaveToFile (FileName);
    ChangeModify (false);
  except
    on Exception do ShowMsgDlg ('could not save file "' + FileName + '"', mtError);
  end;
end;

procedure TMainForm.FileSaveAsMnuClick(Sender: TObject);

  procedure FixExtension;
  var
    sl : TStringList;
    ext : TFileName;
  begin
    if SaveDlg.FilterIndex < 1 then exit;
    sl := TStringList.Create;
    FilterExtensionsToStringList(sl, Filter, false);
    ext := sl[SaveDlg.FilterIndex - 1];
    if ext <> '.*' then
      SaveDlg.FileName := SaveDlg.FileName + ext;
    sl.Free;
  end;

begin
  //set of SaveDlg before SaveDlg.execute
  if ExtractFilePath(FileName) <> '' then
    SaveDlg.InitialDir := ExtractFilePath (FileName);

  SaveDlg.FilterIndex := GetFilterItemIndex ('*' + ExtractFileExt (FileName), Filter);
  if SaveDlg.FilterIndex = 0 then
    SaveDlg.FileName := ExtractFileName (FileName)
  else
    SaveDlg.FileName := ExtractFileName (ChangeExt (FileName, ''));

  if not SaveDlg.execute then exit;
  FixExtension;

  if FileExistsEx (SaveDlg.FileName, true) and
    (MessageDlg (SaveDlg.FileName + ' exists.  Overwrite?', mtWarning, [mbYes, mbNo], 0) = mrNo) then
      exit; //Modified still = true

  SaveDlg.InitialDir := ExtractFilePath (SaveDlg.FileName);
  AddToRecent (FileName, true);
  ChangeGroupFile (FileName, SaveDlg.FileName);
  ChangeFavFile (FileName, SaveDlg.FileName);
  FileName := SaveDlg.FileName;
  if LangWordsList.UpdateCurItem(FileName) then ColorCodeAll;
  SaveCurFile;
end;

procedure TMainForm.SearchFindMnuClick(Sender: TObject);
begin
  FindForm.ShowModal;
end;

procedure TMainForm.SearchReplaceMnuClick(Sender: TObject);
begin
  ReplaceForm.ShowModal;
end;

procedure TMainForm.FilePrintMnuClick(Sender: TObject);
var FileVar : TextFile;
begin
  Printer.Canvas.Font := Edit.Font;
  Printer.Canvas.Font.Color := clBlack;
  Printer.Title := FileName;
  If Edit.SelLength = 0 then
    PrintDlg.Options := PrintDlg.Options - [poSelection]
  else begin
    PrintDlg.Options := PrintDlg.Options + [poSelection];
    PrintDlg.PrintRange := prSelection;
  end;

  if not PrintDlg.Execute then exit;

  AssignPrn (FileVar);
  ReWrite (FileVar);

  if PrintDlg.PrintRange = prSelection then
     WriteLn (FileVar, Edit.SelText)
  else
     WriteLn (FileVar, Edit.Text);

  CloseFile (FileVar);
end;

procedure TMainForm.OptionsFontMnuClick(Sender: TObject);
begin
  FontDlg.Font := Edit.Font;
  if FontDlg.Execute then begin
    //if changed background color
    if FontDlg.Font.Color <> Edit.Font.Color then begin
      ColorScheme := csCustom;
      CustomFore := FontDlg.Font.Color;
      CustomBack := Edit.Color;
    end;

    //if changed font
    if Edit.Font <> FontDlg.Font then begin
      RedrawOn := false;
      SaveAllEditAttributes;
      Edit.Font := FontDlg.Font;
      ColorCodeAll;
      LoadAllEditAttributes;
      RedrawOn := true;
      Edit.Repaint;
    end;
  end;
end;

procedure TMainForm.OptionsEnvironmentMnuClick(Sender: TObject);
begin
  EnvironmentForm.ShowModal;
//  if EnvironmentForm.ShowModal = mrOK then
  //  Edit.Repaint;
end;

procedure TMainForm.EnableView;
var b : boolean;
begin
  b := FilesOpen > 1;
  ViewNextMnu.Enabled := b;
  ViewPreviousMnu.Enabled := b;
  ViewSelectFileMnu.Enabled := b;
  PopupMenu.Items.Items[0].Enabled := b;
  PopupMenu.Items.Items[1].Enabled := b;
  PreviousSpdBtn.Enabled := b;
  NextSpdBtn.Enabled := b;
  ViewSpdBtn.Enabled := b;
  ViewMainFileMnu.Enabled := (GroupOpen > 0) and
    (MainFile[GroupOpen] >= 0);
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  FileVar : TextFile;
  i : integer;
  InStr : string;
  i2, j2, j : cardinal;
  RunMenuItem : TRunMenuItem;
  RecentMenuItem : TRecentMenuItem;
  GroupMenuItem : TGroupMenuItem;
  FavMenuItem : TFavMenuItem;
  ExeOpt : TExeOpt;
begin
  FileTimesNames := TStringList.Create;
  FileTimes := TList.Create;
  Application.OnRestore := OnAppRestore;
  Application.OnActivate := OnAppActivate;
  Application.OnDeactivate := OnAppDeactivate;
  WinNum := 1;
  SourceDir := ExtractFilePath (Application.ExeName);
  FilesOpen := 0;
  CanOpenOptions := false;
  ExeOpts.Create;
  EnterDown := false;
  Clips := TStringList.Create;
  LangWordsList := TLangReservedWordsList.Create;
  PauseColorCoding := 0;
  AttribCount := 0;
  AllAttribCount := 0;
  TextDefaults.Create;
  SearchedFiles := TStringList.Create;

  if not FileExists (SourceDir + OptionsFileName) then begin
    LoadDefaultsIni;

    RunMnu.Enabled := RunMnu.Count > 0;
    EnableView;
    EnableCutCopy;
    {WriteCursPos is not called if Mouse is not
     on Code Edit, which calls OnMouseMove,
     when it starts}
    WriteCursPos;

    GroupOpen := 0;

    if OpenParam = 0 then
      if OpenFile (SourceDir + ReadMeFileName, true) <> coTrue then begin
        FileName := '';
        LangWordsList.UpdateCurItem(FileName);
      end;

    SetScrollBars;
    Insert := true;
    ConfirmPrompt := true;
    AutoIndent := true;

    CreatePopUpMenu;
    MaxRecentNum := MaxMenuRows;
    TabUse.init;
    ClipType := CT_DUAL;
    ColorCodingOn := true;
    SortViewFiles := false;

    exit;
  end;

  inc(PauseColorCoding);

  AssignFile (FileVar, SourceDir + OptionsFileName);
  ReSet (FileVar);
    LangWordsList.LoadFromFile(FileVar);

    ReadLn (FileVar, CustomBack);
    ReadLn (FileVar, CustomFore);
    ReadLn (FileVar, i);
    Edit.SelectAll;
    AssignColorScheme (TColorScheme(i));
    {for some wierd reason, just assigning Font.Color
     won't change Edit's appearance}
    Edit.SelAttributes.Color := Edit.Font.Color;

    ReadLn (FileVar, i);
    case i of
      Ord (kmWindows) : ChangeKeyMap (kmWindows);
      Ord (kmPascal) : ChangeKeyMap (kmPascal);
    end;

    ReadLn (FileVar, i);
    if i > 0 then
      with ExeOpt do begin
        Create;
        for j := 1 to i do begin
          ReadLn (FileVar, inStr);
          SourceExts.CommaText := inStr;
          ReadLn (FileVar, ExeExt);
          ReadLn (FileVar, i2);
          ParamsPrompt := IntToBool (i2);
          ReadLn (FileVar, i2);
          cd := IntToBool (i2);
          ReadLn (FileVar, SaveOrBackupIndex);

          ExeOpts.Add (ExeOpt);
        end;
        Free;
      end;

    ReadLn (FileVar, i);
    ExecuteCurrentFileMnu.ShortCut := i;

    ReadLn (FileVar, i);
    PersistentGroups := IntToBool (i);

    ReadLn (FileVar, i);
    ConfirmPrompt := IntToBool (i);

    ReadLn (FileVar, i);
    AutoIndent := IntToBool (i);

    TabUse.LoadFromFile (FileVar);

    ReadLn (FileVar, GroupOpen);
    with FileOpenGroupMnu do begin
      ReadLn (FileVar, j);

      if j > 0 then
        for i := 0 to j - 1 do begin
          GroupMenuItem := TGroupMenuItem.Create (FileOpenGroupMnu);
          ReadLn (FileVar, InStr);
          GroupMenuItem.Caption := InStr;
          Add (GroupMenuItem);

          new (groups[i + 1]);
          groups[i + 1]^ := TStringList.Create;

          ReadLn (FileVar, j2);
          if j2 > 0 then
            for i2 := 0 to j2 - 1 do begin
              ReadLn (FileVar, InStr);
              groups[i + 1]^.Add (InStr);
            end;

          ReadLn (FileVar, MainFile[i + 1]);
        end;//for i...
    end;//with File...

    ReadLn (FileVar, InStr);
    DefaultExt := inStr;

    ReadLn (FileVar, InStr);
    Filter := InStr;

    ReadLn (FileVar, InStr);
    SaveDlg.InitialDir := InStr;
    ReadLn (FileVar, InStr);
    OpenDlg.InitialDir := InStr;

    ReadLn (FileVar, StartWith);
    if StartWith <> swLastFile then GroupOpen := 0;

    case StartWith of
      swLastFile : begin
        FileName := '';
        LangWordsList.UpdateCurItem(FileName);
        ReadLn (FileVar, i);
        j2 := Ord (i > 1);//j2 iff FilesOpen > 1
        while (i > 0) do begin
          ReadLn (FileVar, InStr);

          i2 := Ord (Edit.Visible);
          if OpenFileBack (InStr, false, not Edit.Visible) = coTrue then begin
            if i2 = 0 then begin
              //if Edit just became visible
              ReadLn (FileVar, j);
              ChangeReadOnly (IntToBool (j));

              ReadLn (FileVar, j);
              Edit.SelStart := j;

              ReadLn (FileVar, j);
              Edit.SelLength := j;

              ReadLn (FileVar, j);
              //EditFirstVisibleLine := j;
              EditVertScrollPos := j;

              ReadLn (FileVar, j);
              EditHorzScrollPos := j;
            end else begin
              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.ReadOnly := IntToBool (j);

              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.SelStart := j;

              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.SelLength := j;

              //Files[FilesOpen - 1]^.FirstVisibleLine := j;
              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.VertScrollPos := j;

              ReadLn (FileVar, j);
              Files[FilesOpen - 1]^.HorzScrollPos := j;
            end;
          end else begin
            ReadLn (FileVar);
            ReadLn (FileVar);
            ReadLn (FileVar);
            ReadLn (FileVar);
            ReadLn (FileVar);
          end;//if...
          dec (i);
        end;//while...

        //j2 iff FilesOpen > 1
        if IntToBool (j2) then begin
          ReadLn (FileVar, i);
          if i >= 0 then ClickTab (Sender, i);
        end;

        {open param will be called after function
         for swLastOpen because it will call CloseAllFiles
         which may call AddToRecent, but here
         FileRecentMnu has not yet been loaded}
      end;//case swLastOpen

      swNewFile : if OpenParam = 0 then NewFile(NextUntitledName, true);
      swNoOpen : if OpenParam = 0 then begin FileName := ''; LangWordsList.UpdateCurItem(FileName); end;
    end;//case
    EnableView;

    ReadLn (FileVar, InStr);
    Edit.Font.Name := InStr;
    ReadLn (FileVar, i);
    Edit.Font.Size := i;

    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsBold];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsItalic];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsUnderLine];
    ReadLn (FileVar, i);
    if i = 1 then Edit.Font.Style := Edit.Font.Style + [fsStrikeOut];
    {Edit.Font.OnChange (Edit);
     to fix font problem in Win 2000;
     it probably doesn't tough;}

    ReadLn (FileVar, i);
    Timer1.Enabled := IntToBool (i);
    ReadLn (FileVar, i);
    Timer1.Interval := i;

    ReadLn (FileVar, i);
    if i = 0 then begin
      WindowState := wsNormal;
      ReadLn (FileVar, i); Top := i;
      ReadLn (FileVar, i); Left := i;
      ReadLn (FileVar, i); Height := i;
      ReadLn (FileVar, i); Width := i;
    end else
      WindowState := wsMaximized;

    ReadLn (FileVar, i);
    ViewShowClipMnu.Checked := IntToBool (i);

    ReadLn (FileVar, i);
    ViewScrollBarsMnu.Checked := IntToBool (i);

    ReadLn (FileVar, i);
    ShowTabs (IntToBool (i));

    ReadLn (FileVar, i);
    ShowToolBar (IntToBool (i));

    ReadLn (FileVar, i);
    ShowStatusBar (IntToBool (i));

    ReadLn (FileVar, i);
    SetWrap (IntToBool (i));

    ReadLn (FileVar, i);
    if not IntToBool (i) then begin
      {Edit's insert apparaently defaults to true, so
       assigning true to insert puts Insert in phase w/
       Edit's insert}
      FInsert := true;
      {this will call KeyDown which will call Insert :=,
       but it also changes Edit's insert}
      Edit.Perform (WM_KEYDOWN, VK_INSERT, 0);
    end else Insert := true;

    ReadLn (FileVar, NumOfRecs);
    RunMnu.Enabled := NumOfRecs > 0;
    if NumOfRecs > 0 then
      for j := 1 to NumOfRecs do begin
        RunMenuItem := TRunMenuItem.Create (RunMnu);
        New (Progs[j]);
        ReadLn (FileVar, Progs[j]^.Prog);
        ReadLn (FileVar, Progs[j]^.Params);
        ReadLn (FileVar, i);
        Progs[j]^.SaveOrBackupIndex := i;
        ReadLn (FileVar, InStr);
        RunMenuItem.Caption := InStr;
        ReadLn (FileVar, i);
        RunMenuItem.ShortCut := i;
        RunMenuItem.Tag := j;
        RunMnu.Add (RunMenuItem);

        Progs[j]^.BatFile := TStringList.Create;
        ReadLn (FileVar, i);
        while (i > 0) do begin
          ReadLn (FileVar, InStr);
          Progs[j]^.BatFile.Insert (Progs[j]^.BatFile.Count, InStr);
          dec (i);
        end;
      end;

    //if not Registered then ShowUnregMsg;

    ReadLn (FileVar, i);
    Application.ShowHint := IntToBool (i);
    ReadLn (FileVar, i);
    Application.HintPause := i;
    ReadLn (FileVar, i);
    Application.HintHidePause := i;

    ReadLn (FileVar, j);
    if j > 0 then
      for i := 0 to j - 1 do begin
        RecentMenuItem := TRecentMenuItem.Create (FileRecentMnu);
        ReadLn (FileVar, InStr);
        RecentMenuItem.Caption := InStr;
        FileRecentMnu.Add (RecentMenuItem);
      end;
    ReadLn (FileVar, j);
    MaxRecentNum := j;

    ReadLn (FileVar, j);
    if j > 0 then
      for i := 0 to j - 1 do begin
        FavMenuItem := TFavMenuItem.Create (FileFavoritesMnu);
        ReadLn (FileVar, InStr);
        FavMenuItem.Caption := InStr;
        FileFavoritesMnu.Add (FavMenuItem);
      end;

    ReadLn (FileVar, i);
    BackupExt := IntToBackupExt (i);

    ReadLn (FileVar, i);
    SortViewFiles := IntToBool(i);
    
    ReadLn (FileVar, i);
    ClipType := i;
    ReadLn(FileVar, i);
    ColorCodingOn := IntToBool(i);

    TextDefaults.LoadFromFile(FileVar);
  CloseFile (FileVar);

  dec(PauseColorCoding);
  ColorCodeAll;

  CreatePopUpMenu;
  //see end of case swLastOpen above for explination
  if StartWith = swLastFile then OpenParam;
end;

procedure TMainForm.SaveOptions;
var
  FileVar : TextFile;
  i, j : byte;
begin
  if IsOptionsFile (FileName, false) then CloseCurFile;

  AssignFile (FileVar, SourceDir + OptionsFileName);
  ReWrite (FileVar);
    LangWordsList.SaveToFile(FileVar);

    WriteLn (FileVar, CustomBack);
    WriteLn (FileVar, CustomFore);
    WriteLn (FileVar, Ord (ColorScheme));
    WriteLn (FileVar, Ord (KeyMap));

    WriteLn (FileVar, ExeOpts.GetCount);
    if ExeOpts.GetCount > 0 then
      for i := 0 to ExeOpts.GetCount - 1 do
        with ExeOpts.Items[i]^ do begin
          WriteLn (FileVar, SourceExts.CommaText);
          WriteLn (FileVar, ExeExt);
          WriteLn (FileVar, Ord (ParamsPrompt));
          WriteLn (FileVar, Ord (cd));
          WriteLn (FileVar, SaveOrBackupIndex);
        end;//with...

    WriteLn (FileVar, ExecuteCurrentFileMnu.ShortCut);

    WriteLn (FileVar, Ord (PersistentGroups));
    WriteLn (FileVar, Ord (ConfirmPrompt));
    WriteLn (FileVar, Ord (AutoIndent));
    TabUse.SaveToFile (FileVar);

    WriteLn (FileVar, GroupOpen);
    with FileOpenGroupMnu do begin
      WriteLn (FileVar, Count);

      if Count > 0 then
        for i := 0 to Count - 1 do begin
          WriteLn (FileVar, Items[i].Caption);

          with groups[i + 1]^ do begin
            WriteLn (FileVar, Count);
            if Count > 0 then
              for j := 0 to Count - 1 do
                WriteLn (FileVar, Strings[j]);
          end;//with groups...

          WriteLn (FileVar, MainFile[i + 1]);
        end;//for...
    end;//with File...

    WriteLn (FileVar, DefaultExt);
    WriteLn (FileVar, Filter);
    WriteLn (FileVar, SaveDlg.InitialDir);
    WriteLn (FileVar, OpenDlg.InitialDir);

    WriteLn (FileVar, StartWith);
    if StartWith = swLastFile then begin
      WriteLn (FileVar, FilesOpen);
      if FilesOpen > 0 then begin
        for j := 0 to Tabs.Tabs.Count - 1 do begin
          i := TabFiles[j];
          if i = 0 then begin
            WriteLn (FileVar, FileName);
            WriteLn (FileVar, Ord (Edit.ReadOnly));
            WriteLn (FileVar, Edit.SelStart);
            WriteLn (FileVar, Edit.SelLength);
            //WriteLn (FileVar, EditFirstVisibleLine);
            WriteLn (FileVar, EditVertScrollPos);
            WriteLn (FileVar, EditHorzScrollPos);
          end else begin
            WriteLn (FileVar, Files[i]^.FileName);
            WriteLn (FileVar, Ord (Files[i]^.ReadOnly));
            WriteLn (FileVar, Files[i]^.SelStart);
            WriteLn (FileVar, Files[i]^.SelLength);
            //WriteLn (FileVar, Files[i]^.FirstVisibleLine);
            WriteLn(FileVar, Files[i]^.VertScrollPos);
            WriteLn(FileVar, Files[i]^.HorzScrollPos);
          end;
        end;

        if FilesOpen > 1 then WriteLn (FileVar, InvTabFiles (0));
      end;//if FilesOepn...
    end else begin//if StartWith...
      {if not swLastFile then all files are
       closed and should be added to recent}
      if FilesOpen > 0 then begin
        AddToRecent (FileName, true);
        if FilesOpen > 1 then
          for i := 1 to FilesOpen - 1 do
            AddToRecent (Files[i]^.FileName, true);
      end;
    end;

    WriteLn (FileVar, Edit.Font.Name);
    WriteLn (FileVar, Edit.Font.Size);
    WriteLn (FileVar, ord (fsBold in Edit.Font.Style));
    WriteLn (FileVar, ord (fsItalic in Edit.Font.Style));
    WriteLn (FileVar, ord (fsUnderLine in Edit.Font.Style));
    WriteLn (FileVar, ord (fsStrikeOut in Edit.Font.Style));

    WriteLn (FileVar, Ord (Timer1.Enabled));
    WriteLn (FileVar, Timer1.Interval);

    WriteLn (FileVar, ord (WindowState));
    if WindowState = wsNormal then begin
      WriteLn (FileVar, Top);
      WriteLn (FileVar, Left);
      WriteLn (FileVar, Height);
      WriteLn (FileVar, Width);
    end;

    WriteLn (FileVar, Ord (ViewShowClipMnu.Checked));
    WriteLn (FileVar, Ord (ViewScrollBarsMnu.Checked));
    WriteLn (FileVar, Ord (ViewTabsMnu.Checked));
    WriteLn (FileVar, Ord (ViewToolBarMnu.Checked));
    WriteLn (FileVar, Ord (ViewStatusBarMnu.Checked));
    WriteLn (FileVar, Ord (WrapMnu.Checked));
    WriteLn (FileVar, Ord (Insert));

    WriteLn (FileVar, NumOfRecs);
    if NumOfRecs > 0 then
      for i := 1 to NumOfRecs do begin
        WriteLn (FileVar, Progs[i]^.Prog);
        WriteLn (FileVar, Progs[i]^.Params);
        WriteLn (FileVar, Progs[i]^.SaveOrBackupIndex);
        WriteLn (FileVar, RunMnu.Items[i - 1].Caption);
        WriteLn (FileVar, RunMnu.Items[i - 1].ShortCut);

        WriteLn (FileVar, Progs[i]^.BatFile.Count);
        if Progs[i]^.BatFile.Count > 0 then
          for j := 0 to Progs[i]^.BatFile.Count - 1 do
            WriteLn (FileVar, Progs[i]^.BatFile[j]);
      end;

    WriteLn (FileVar, Ord (Application.ShowHint));
    WriteLn (FileVar, Application.HintPause);
    WriteLn (FileVar, Application.HintHidePause);

    with FileRecentMnu do begin
      WriteLn (FileVar, Count);
      if Count > 0 then
        for i := 0 to Count - 1 do
          WriteLn (FileVar, Items[i].Caption);
    end;//with...
    WriteLn (FileVar, MaxRecentNum);

    with FileFavoritesMnu do begin
      WriteLn (FileVar, Count);
      if Count > 0 then
        for i := 0 to Count - 1 do
          WriteLn (FileVar, Items[i].Caption);
    end;//with...

    WriteLn (FileVar, Ord (BackupExt));
    WriteLn (FileVar, Ord (ViewForm.SortCB.Checked));

    WriteLn (FileVar, ClipType);
    WriteLn (FileVar, Ord(ColorCodingOn));

    TextDefaults.SaveToFile(FileVar);
  CloseFile (FileVar);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var i : byte;
begin
  if FilesOpen > 1 then
    {The for loop uses a downto because higher
     items must be removed from a menu before
     lower ones.}
    for i := FilesOpen - 1 downto 1 do
      Dispose (Files[i]);

  if NumOfRecs > 0 then
    for i := 1 to NumOfRecs do
      Dispose (Progs[i]);

  if FileOpenGroupMnu.Count > 0 then
    for i := 1 to FileOpenGroupMnu.Count do
      Dispose (groups[i]);

  ExeOpts.Free;
  LangWordsList.Free;
  TextDefaults.Free;
  SearchedFiles.Free;
  FileTimesNames.Free;
  FileTimes.Free;

  //delete temporary files
  //DeleteFile(SourceDir + TempBatFileName);
  DeleteFile(ChangeExt (TempBatFileName, 'pif'));
  //DeleteFile(SourceDir + TempPromptFileName);
  DeleteFile(ChangeExt (TempPromptFileName, 'pif'));
  DeleteFile(SourceDir + FN_TEMP_RTF);

  //GlobalDeleteAtom(atom);
end;

function TMainForm.CloseCurFile : boolean;
begin
  if not Edit.Visible then begin
    result := false;
    exit;
  end;

  if Edit.Modified then
    if SaveChanges (0, true) = mrCancel then begin
      result := false;
      exit;
    end;

  AddToRecent (FileName, true);

  dec (FilesOpen);

  LeftShiftTabFilesAt (Tabs.TabIndex);
  Tabs.Tabs.Delete (Tabs.TabIndex);
  Tabs.TabIndex := InvTabFiles (FilesOpen);
  if Tabs.TabIndex >= 0 then TabFiles[Tabs.TabIndex] := 0;

  if FilesOpen = 0 then begin
    MainForm.Edit.Clear;
    MainForm.FileName := '';//FileName := '' hides Edit
    LangWordsList.UpdateCurItem(FileName);
  end else
    AryToEdit;

  EnableView;
  result := true;
end;

{procedure to CloseCurFile if an error occurs while
 opening it}
procedure TMainForm.CloseCurFileOnError;
begin
  dec (FilesOpen);
  if FilesOpen = 0 then begin
    Tabs.Tabs.Delete(0);
    Edit.Clear;
    FileName := '';//FileName := '' hides Edit
    LangWordsList.UpdateCurItem(FileName);
  end else
    AryToEdit;

  EnableView;
end;

procedure TMainForm.FileNewMnuClick(Sender: TObject);
begin
  if FilesOpen = MAX_FILE_NUM then begin
    ShowMsgDlg ('No more Files can be Opened!', mtWarning);
    exit;
  end;

  if NewForm.ShowModal = mrCancel then exit;
  NewFile(NewForm.FileName, NewForm.UseDefaultCB.Checked);
end;

procedure TMainForm.FileExitMnuClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditSelectAllMnuClick(Sender: TObject);
begin
  Edit.SelectAll;
end;

procedure TMainForm.EditCutMnuClick(Sender: TObject);
begin
  EditCut;
end;

procedure TMainForm.EditCopyMnuClick(Sender: TObject);
begin
  EditCopy;
end;

procedure TMainForm.EditPasteMnuClick(Sender: TObject);
begin
  EditPaste;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  If MainForm.Active then begin
    if Timer1.Interval = 1000 then
      Timer1.Interval := Timer1.Tag;

    FileSaveAllMnu.Click;
  end else if Timer1.Interval <> 1000 then begin
    Timer1.Tag := Timer1.Interval;
    Timer1.Interval := 1000;
  end;
end;

procedure TMainForm.SearchSearchAgainMnuClick(Sender: TObject);
begin
  if FindText = '' then
    FindForm.ShowModal
  else begin
    FindText := FindForm.FindEdit.Text;
    if not Search (FindForm.Options, FindForm.FindInFilesCB.Checked) then
      ShowFoundDlg (true);
  end;
end;

function TMainForm.Search (const Options : TSearchTypes; findInFiles : boolean): boolean;
var
  i : integer;
  len : cardinal;
begin
  if SearchedFiles.IndexOf(FileName) <> -1 then begin
    result := false;
    exit;
  end;
  
  len := length (FindText);

  {FindPosition is the character at the the
   start of the characters that are searched
   through rather than the character before,
   thus the need for a minus one in i's
   assignment.}

  i := Edit.FindText (FindText, FindPosition, EndFindPosition - FindPosition + 1, Options);
  result := i >= 0;

  if result then begin
    FindPosition := i + len;

    Edit.Perform (EM_SETSEL, i, i + len);
    WriteCursPos;
  end else if findInFiles then begin
    SearchedFiles.Add(FileName);
    ViewNextMnu.Click;
    FindForm.SetFindPositions;
    result := result or Search(Options, findInFiles);
  end else
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  {Makes UpDown1.Position at least 0; here in
   case someone uses UpDown1 then resizes
   MainForm where UpDown1 is still visible;
   0 is the maximum value of UpDown1.Position}
  while UpDown1.Position < 0 do begin
    UpDown1.Position := UpDown1.Position + 1;
    UpDown1.OnClick (Sender, btNext);
  end;

  {Make UpDown1 visible if MainForm is resized
   so that the last Speed Button, HelpSpdBtn,
   is not totally visible}
  UpDown1.Visible :=
    ToolBar.Width < HelpSpdBtn.Left
    + HelpSpdBtn.Width;

  {Put UpDown1 in right corner of Panel1}
  UpDown1.Left := ToolBar.Width - UpDown1.Width
                  - 7;

  {Min should = - Number of clicks needed to
   move HelpSpdBtn completely to the left of
   UpDown1 by moving the width of a Speed
   Button per click. The 1st 3 variables in ()
   repRecent the total maximum distance
   distance buttons will have to be able to
   move; it's div by the distance moved per
   click; - 1 because the number of click
   should be rounded up, the 1 and a div
   which rounds down gives the answer as if it
   were a division rounded up w/o the 1; 1 is
   - because UpDown1.Min is -}
  UpDown1.Min :=
    (UpDown1.Left - HelpSpdBtn.Left -
    HelpSpdBtn.Width)
    div ToolBar.Controls[0].Width - 1;
end;

{if gotoFile, then the file is always shown in Edit;
 if not gotoFile, it will still be shown in Edit if it
 does not exist (so a SaveAs can be done)}
function TMainForm.SaveChanges (i : byte; gotoFile : boolean) : word;
var
  fName : TFileName;
  forceGoto : boolean;
begin
  Assert(i < FilesOpen);

  if ((i = 0) and (not Edit.Modified)) or ((i > 0) and (not Files[i]^.Modified)) then begin
    result := mrYes;
    exit;
  end;

  if i = 0 then
    fName := FileName
  else
    fName := Files[i]^.FileName;

  forceGoto := not FileExistsEx(fName, true);

  if gotoFile or forceGoto then begin
    if i > 0 then SwapEditAry (i);
    if gotoFile then
      result := MessageDlg ('Save Changes to ' + FileName + '?', mtConfirmation, mbYesNoCancel, 0)
    else
      result := mrYes;

    try
      if result = mrYes then FileSaveMnu.Click;
    except
      on WriteErr : EWriteError do begin
        ShowMsgDlg (WriteErr.Message, mtError);
        result := mrCancel;
      end;
    end;

    if i > 0 then SwapEditAry (i);
  end else begin
    if i = 0 then
      FileSaveMnu.Click
    else
      Files[i]^.Save;

    result := mrYes;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var i : integer;
begin
  with SaveModifiedForm do
    with FileNums do begin
      Clear;
      if (FilesOpen > 0) and Edit.Modified then
        Add(newInteger(0));
      if FilesOpen > 1 then
        for i := 1 to FilesOpen - 1 do
          if MainForm.Files[i]^.Modified then
            Add(newInteger(i));

      if (Count = 0) or (ShowModal = mrOK) then begin
        Action := caFree;
        SaveOptions;
      end else
        Action := caNone;

    end;//with...
  {if FilesOpen > 0 then
    for i := 0 to FilesOpen - 1 do
      if ((i = 0) and (Edit.Modified)) or ((i > 0) and (Files[i]^.Modified)) then
        case SaveChanges (i) of
          mrYes : begin
            if ((i = 0) and (Edit.Modified)) or ((i > 0) and (Files[i]^.Modified)) then
              if MessageDlg ('Still Wish to Exit Without Saving Changes?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
                Action := caNone;
                exit;
              end;
          end;//mrYes : begin

          mrCancel : begin
            Action := caNone;
            exit;
          end;
        end;}

end;

procedure TMainForm.FileSaveAllMnuClick(Sender: TObject);

  procedure SimulateTabClick (i : byte);
  begin
    PrevTabIndex := Tabs.TabIndex;
    Tabs.TabIndex := InvTabFiles (i);
  end;

var i : byte;
begin
  FileSaveMnu.Click;

  for i := 1 to FilesOpen - 1 do
    if not FileExistsEx(Files[i]^.FileName, true) then begin
      {next two lines are here because SwapEditAry
       calls SetFileName which uses TabIndex to write
       FileName on a tab, so TabIndex must be
       correct for SetFileName}
      SimulateTabClick (i);
      SwapEditAry (i);
      FileSaveAsMnu.Click;
      if Edit.Modified then
        if MessageDlg ('Do you wish to continue saving files?',
                       mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
          SimulateTabClick (i);
          SwapEditAry (i);
          exit;
        end;

      SimulateTabClick (i);
      SwapEditAry (i);
    end else
      Files[i]^.Save;

  WriteModified;
end;

procedure TMainForm.EditDeleteMnuClick(Sender: TObject);
begin
  with Edit do begin
    ClearSelection;
    InvalidateLines(Perform(EM_LINEFROMCHAR, -1, 0), Lines.Count - 1);
  end;
end;

procedure TMainForm.ViewNextMnuClick(Sender: TObject);
begin
  with Tabs do
    if TabIndex + 1 = Tabs.Count then
      ClickTab (Sender, 0)
    else
      ClickTab (Sender, TabIndex + 1);
end;

procedure TMainForm.ViewPreviousMnuClick(Sender: TObject);
begin
  with Tabs do
    if TabIndex = 0 then
      ClickTab (Sender, Tabs.Count - 1)
    else
      ClickTab (Sender, TabIndex - 1);
end;

procedure TMainForm.SearchGotoLineNumberMnuClick(Sender: TObject);
var
  LineCount, LineNum : integer;
  LineNumStr : string;
begin
  if not InputQuery ('Goto', 'Input line number to goto', LineNumStr) then exit;

  LineNum := Int (LineNumStr);
  if LineNum = 0 then begin
    ShowMsgDlg ('Inavlid Line Number', mtWarning);
    exit;
  end;

  LineCount := Edit.Perform (EM_GetLineCount, 0, 0);

  if LineNum > LineCount then
    LineNum := LineCount;

  Edit.SelStart :=
    Edit.Perform (EM_LineIndex, LineNum - 1, 0);

  Edit.Perform (EM_ScrollCaret, 0, 0);
end;

procedure TMainForm.WrapMnuClick(Sender: TObject);
begin
  SetWrap (not WrapMnu.Checked);
end;

procedure TMainForm.SetWrap (b : boolean);
begin
  RedrawOn := false;
  SaveEditAttributes;

  WrapMnu.Checked := b;
  Edit.WordWrap := b;
  SetScrollBars;

  LoadEditAttributes;
  RedrawOn := true;
  WriteCursPos;
end;

procedure TMainForm.SetScrollBars;
begin
  SaveEditAttributes;

  if ViewScrollBarsMnu.Checked then
    if Edit.WordWrap then
      Edit.ScrollBars := ssVertical
    else
      Edit.ScrollBars := ssBoth
  else
    Edit.ScrollBars := ssNone;

  LoadEditAttributes;
end;

procedure TMainForm.SetInsert (b : boolean);
begin
  FInsert := b;
  if not Edit.Visible then exit;
  if Insert then
    StatusBar1.Panels[PN_INSERT].Text := 'Insert'
  else
    StatusBar1.Panels[PN_INSERT].Text := 'Overwrite';
end;

procedure TMainForm.SetClipType (i : byte);
begin
  FClipType := i;
  case FClipType of
    CT_DUAL : ClipboardDualMnu.Checked := true;
    CT_STACK : ClipboardStackMnu.Checked := true;
    CT_QUEUE : ClipboardQueueMnu.Checked := true;
  end;
  ClipboardSwapClipMnu.Enabled := FClipType = CT_DUAL;
  if (FClipType = CT_STACK) or (FClipType = CT_QUEUE) then begin
    Clipboard.AsText := '';
    CBtoPanel;
  end;
  Clips.Clear;
end;

procedure TMainForm.EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  EnableCutCopy;
  WriteCursPos;

  if LastSelLength <> Edit.SelLength then begin
    LastSelLength := Edit.SelLength;
    LastStart := Edit.SelStart;
  end;

  DoCBtoPanel := ((ssCtrl in Shift) and (Key = VK_INSERT))
    or ((ssShift in Shift) and (Key = VK_DELETE));

  if Key = VK_ESCAPE then EmailTitleToClip;

  if (Key = VK_INSERT) and (Shift = []) then
    Insert := not Insert;

  if Key = VK_F4 then FixColor;

  if (Key = VK_F10) and (ssShift in Shift) then
    PopupMenu.Popup (Left + Edit.Left + 6, Top + Edit.Top + ToolBar.Height + 11);

  if (Key = VK_DELETE) and (Shift = []) and (Edit.SelLength <> 0) then begin
    Key := 0;
    EditDeleteMnu.Click;
  end;

  if AutoIndent and (Key = VK_RETURN) then begin
    SelStartOffset := Edit.SelStart - Edit.Perform (EM_LINEINDEX, -1, 0);
    indent := GetIndent (Edit.Perform (EM_LINEFROMCHAR, -1, 0));
    SelStartOffset := min (SelStartOffset, length (indent));
    EnterDown := true;
  end;

  if (ssShift in Shift) and (Key = VK_DELETE) then begin
    EditCut;
    Key := 0;
  end;

  if (ssCtrl in Shift) and (Key = VK_INSERT) then begin
    EditCopy;
    Key := 0;
  end;

  if (ssShift in Shift) and (Key = VK_INSERT) then begin
    EditPaste;
    Key := 0;
  end;
end;

procedure TMainForm.EditMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var lastEndLine : integer;
begin
  if Key = VK_RETURN then begin
     lastEndLine := Edit.SelStart - 2;
    if (0 <= lastEndLine) and (lastEndLine <= Edit.GetTextLen) then begin
      ColorCodeWord(lastEndLine);
      {invalidate to get rid of "ghost" caret left when
       no autoindention occurs}
      InvalidateChars(Edit.SelStart);
    end;
    {EnterDown is needed so indention won't take place
     when someone presses enter to close a dialog box.
     EnterDown is true iff enter was pressed in the Edit
     (see EditKeyDown)}
    if EnterDown then begin
      EnterDown := false;
      AutoIndentCurLine;
    {color coding with a dialog open prevents the part of
     Edit behind it from being invalidate}
    end else Edit.Invalidate;
  end;

  if DoCBToPanel then CBtoPanel;
  WriteModified;
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.WriteCursPos;
var point : TPoint;
begin
  if not Edit.Visible then exit;
  point := GetCaretPos;
  StatusBar1.Panels[PN_POS].Text :=
    IntToStr (point.y + 1) +
    ': ' +
    IntToStr (point.x + 1);
end;

procedure TMainForm.EnableCutCopy;
begin
  if Edit.SelText <> '' then begin
    EditCutMnu.Enabled := true;
    EditCopyMnu.Enabled := true;
    EditDeleteMnu.Enabled := true;
    CutSpdBtn.Enabled := true;
    CopySpdBtn.Enabled := true;
    PopupMenu.Items[3].Enabled := true;
    PopupMenu.Items[4].Enabled := true;
    PopupMenu.Items[6].Enabled := true;
  end else begin
    EditCutMnu.Enabled := false;
    EditCopyMnu.Enabled := false;
    EditDeleteMnu.Enabled := false;
    CutSpdBtn.Enabled := false;
    CopySpdBtn.Enabled := false;
    PopupMenu.Items[3].Enabled := false;
    PopupMenu.Items[4].Enabled := false;
    PopupMenu.Items[6].Enabled := false;
  end;
end;

procedure TMainForm.ShowToolBar (b : boolean);
begin
  if b = ToolBar.Visible then exit;

  ToolBar.Visible := b;
  if ToolBar.Visible then begin
    Edit.Top := 35;
    Edit.Height := Edit.Height - 35;
  end else begin
    Edit.Top := 0;
    Edit.Height := Edit.Height + 35;
  end;
  ViewToolbarMnu.Checked := b;
end;

procedure TMainForm.OptionsRunMnuClick(Sender: TObject);
begin
  RunForm.ShowModal;
end;

procedure TMainForm.EditUndoMnuClick(Sender: TObject);
begin
  Edit.Perform (EM_Undo, 0, 0);
end;

procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);

  procedure WriteSpaces (i : integer);
  var j : integer;
  begin
    if i <= 0 then exit;
    RedrawOn := false;
    for j := 1 to i do
      Edit.Perform (WM_CHAR, ord (' '), 0);

    RedrawOn := true;
    InvalidateChars(Edit.SelStart - i);
  end;

var point : TPoint;
begin
  if (Key = chr(VK_TAB)) and TabUse.UseSpaces then begin
    point := GetCaretPos;
    Key := #0;
    WriteSpaces ((point.x div TabUse.TabSize + 1) * TabUse.TabSize - point.x);
  end;
end;

procedure TMainForm.FilePrintSetupMnuClick(Sender: TObject);
begin
  PrinterSetupDlg.Execute;
end;

procedure TMainForm.EditMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  LastStart := Edit.SelStart;
end;

procedure TMainForm.ExecuteDOSPromptMnuClick(Sender: TObject);
begin
  MakeTempBatFile (TempPromptFileName, FileName, 'command.com', false);
  Execute (SourceDir + TempPromptFileName);
end;

procedure TMainForm.OptionsExecuteMnuClick(Sender: TObject);
begin
  ExeOptForm.ShowModal;
  ExecuteCurrentFileMnu.Enabled := ExeOpts.IndexOfSource (ExtractFileExt (FileName)) >= 0;
  ExecuteSpdBtn.Enabled := ExecuteCurrentFileMnu.Enabled;
end;

procedure TMainForm.ExecuteCurrentFileMnuClick(Sender: TObject);
var
  s, Params, Dir : string;
  i : SmallInt;
begin
  i := ExeOpts.IndexOfSource (ExtractFileExt (FileName));
  if i < 0 then begin
    ShowMsgDlg ('Use Options|Execute Menu to set an executable extension for extension "' + ExtractFileExt (FileName) + '"', mtWarning);
    exit;
  end;

  with ExeOpts.Items[i]^ do begin
    case SaveOrBackupIndex of
      0 : begin
        FileSaveMnu.Click;

        if Edit.Modified then //save was cancled
          if MessageDlg ('Still wish to execute Current File?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;
      end;

      1 : begin
        FileSaveAllMnu.Click;

        {If any files are modified, some save
         must have been cancled}
        if AnyModified then
          if MessageDlg ('Still wish to execute Current File?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;
      end;

      2 : FileBackupCurrentFileMnu.Click;
      3 : FileBackupAllFilesMnu.Click;
    end;//case

    s := ChangeExt (GetMainFile, ExeExt);

    if ParamsPrompt then
      if not InputQuery ('Parameters', 'Input Parameters for ' + s, Params) then begin
        if MessageDlg ('Still with to execute current file?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
          exit;

        Params := '';
      end else
        s := s + ' ' + Params;

    if cd then begin
      dir := ExtractFilePath (s);
      if DirectoryExists (dir) then
        chdir (dir);
    end;

    Execute (s);
  end;//with ExeOptRec...
end;

procedure TMainForm.FileReloadMnuClick(Sender: TObject);
begin
  if CanOpen (FileName, true) <> coTrue then exit;

  if ConfirmPrompt then
    if MessageDlg ('Reload "' + FileName + '"?',
                    mtConfirmation, [mbYes, mbNo], 0)
      = mrNo then exit;

  ReloadFile(FileName);
end;

procedure TMainForm.EditDeleteLineMnuClick(Sender: TObject);
begin
  Edit.Lines.Delete (Edit.Perform (EM_LineFromChar, -1, 0));
end;

procedure TMainForm.ExecuteDOSComMnuClick(Sender: TObject);
var command : string;
begin
  if InputQuery ('DOS Command', 'Input a DOS Command to be executed', command) then
  begin
    MakeTempBatFile (TempBatFileName, FileName, command, true);
    Execute (SourceDir + TempBatFileName);
  end;
end;

procedure TMainForm.ChangeReadOnly (b : boolean);
begin
  Edit.ReadOnly := b;
  OptionsReadOnlyMnu.Checked := b;
end;

procedure TMainForm.OptionsReadOnlyMnuClick(Sender: TObject);
begin
  ChangeReadOnly (not Edit.ReadOnly);
end;

//returns the number of files successfully opened
function TMainForm.OpenParam : integer;
  function ParamStrRange(i1, i2 : integer) : TFileName;
  var i : integer;
  begin
    result := ParamStr(i1);
    if i1 < i2 then
      for i := i1 + 1 to i2 do
        result := result + ' ' + ParamStr(i);
  end;

  function GetLongest(var i : integer) : TFileName;
  var j : integer;
  begin
    assert(i >= 1);
    assert(i <= ParamCount);

    if i < ParamCount then
      for j := ParamCount downto i + 1 do
        if CanOpen(ParamStrRange(i, j), false) = coTrue then begin
          result := ParamStrRange(i, j);
          i := j;
          exit;
        end;

    result := ParamStr(i);
  end;

var
  i : integer;
  fName : TFileName;
begin
  result := 0;
  if ParamCount < 1 then exit;
  CloseAllFiles;

  i := 1;
  while (i <= ParamCount) do begin
  //for i := 1 to ParamCount do begin
    fName := GetLongest(i);//GetLongest changes i
    try
      fName := LongNameOf(fName);
      if OpenFileBack(fName, false, FilesOpen = 0) <> coTrue then
        NewFile(fName, true);
    except
      on Exception do
        if OpenFileBack(fName, false, FilesOpen = 0) <> coTrue then
          NewFile(fName, true);
    end;
    inc(i);
  end;

  result := ParamCount;
end;

procedure TMainForm.HelpAboutMnuClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.EditMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  EnableCutCopy;
  WriteCursPos;
end;

procedure TMainForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
  Shift : SmallInt;
  i : byte;
begin
  if Button = btPrev then
    Shift := - NewSpdBtn.Width
  else
    Shift := NewSpdBtn.Width;

  with ToolBar do
    for i := 0 to ControlCount - 1 do
      if Controls[i] <> UpDown1 then
        Controls[i].Left := Controls[i].Left + Shift;
end;

procedure TMainForm.EditCutLineMnuClick(Sender: TObject);
begin
  Edit.SelStart := Edit.Perform (EM_LineIndex, -1, 0);
  Edit.SelLength := length (Edit.Lines[Edit.Perform (EM_LineFromChar, -1, 0)]) + 2;
  EditCut;
end;

function TMainForm.AnyModified : boolean;
var i : byte;
begin
    result := Edit.Modified;

    if FilesOpen > 1 then
      for i := 1 to FilesOpen - 1 do
        if Files[i]^.Modified then
          result := true;
end;

function TMainForm.CanAddToRecent (const fName : TFileName) : boolean;
begin
  if not FileExistsEx (fName, true) then begin
    result := false;
    exit;
  end;

  if InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if InFav (fName) >= 0 then begin
    result := false;
    exit;
  end;

  if IsOptionsFile (fname, false) then begin
    result := false;
    exit;
  end;

  result := true;
end;

function TMainForm.AddToRecent (const fName : TFileName; check : boolean) : boolean;
var
  i : byte;
  MenuItem : TRecentMenuItem;
begin
  {if check then checks are performed to see if
   fName can validly be added to recent}
  if check then begin
    result := CanAddToRecent (fName);
    if not result then exit;
  end else
    result := true;

  {Numbers are deleted from FileRecentMnu, the
   items are switched around appropriately,
   then the number are put back}
  DeleteRecentNums;
  with FileRecentMnu do begin
    {deletes menu item if it's already in
     FileRecentMnu}
    if Count > 0 then
      for i := 0 to Count - 1 do
        if StrCmpi (fName, CapToStr (Items[i].Caption)) then begin
          Delete (i);
          system.break;
        end;

    {Deletes the last item if FileRecentMnu
     is full}
    if Count = MaxRecentNum then Delete (Count - 1);

    MenuItem := TRecentMenuItem.Create (FileRecentMnu);
    MenuItem.Caption := fName;

    //add most recent item to top
    Insert (0, MenuItem);
  end;//with...
  AddRecentNums;
end;

//takes away the numbers in FileRecentMnu
procedure TMainForm.DeleteRecentNums;
var i : byte;
begin
  i := 0;

  with FileRecentMnu do
    while (i < Count) and (i < 10) do begin
      Items[i].Caption := CapToStr (Items[i].Caption);
      inc (i);
    end;
end;

//Numbers items in FileRecentMnu
procedure TMainForm.AddRecentNums;
var i : byte;
begin
  i := 0;

  with FileRecentMnu do
    while (i < Count) and (i < 10) do begin
      Items[i].Caption := StrToCap (Items[i].Caption, i + 1);
      inc (i);
    end;
end;

procedure TMainForm.FileMnuClick(Sender: TObject);
begin
  FileReloadMnu.Enabled := FileExistsEx (FileName, true);
  FileRecentMnu.Enabled := FileRecentMnu.Count > 0;
  FileOpenGroupMnu.Enabled := FileOpenGroupMnu.Count > 0;
  FileFavoritesMnu.Enabled := FileFavoritesMnu.Count > 0;
  AddGroupMnu.Enabled := (GroupOpen > 0) and not InCurGroup (FileName);
  AddFavoritesMnu.Enabled := InFav (FileName) < 0;
  FileCloseGroupMnu.Enabled := GroupOpen > 0;
  FileSelectionMnu.Enabled := (Edit.SelLength > 0) and (FilesOpen > 0);
end;

procedure TMainForm.OptionsOpenGroupMenuClick(Sender: TObject);
begin
  GroupForm.ShowModal;
end;

function TMainForm.IsOpen (const fName : TFileName) : boolean;
var i : byte;
begin
  if fName = FileName then begin
    result := true;
    exit;
  end;

  if FilesOpen > 1 then
    for i := 1 to FilesOpen - 1 do
      if fName = Files[i]^.FileName then begin
        result := true;
        exit;
      end;

  result := false;
end;

function TMainForm.RemoveFromRecent (const fName : TFileName) : boolean;
var i : integer;
begin
  i := RecentPos (fName);

  result := i >= 0;
  if not result then exit;

  with FileRecentMnu.Items[i] do begin
    tag := 1;//signal for click to remove item
    Click;
    tag := 0;
  end;
end;

function TMainForm.RecentPos (const fName : TFileName) : integer;
var i : integer;
begin
  with FileRecentMnu do
    if Count > 0 then
      for i := 0 to Count - 1 do
        if StrCmpi (fName, CapToStr (Items[i].Caption)) then begin
          result := i;
          exit;
        end;

  result := -1;
end;

procedure TMainForm.FileCloseGroupMnuClick(Sender: TObject);
begin
  CloseOpenGroup;
end;

//returns true only if all files in group are closed
function TMainForm.CloseOpenGroup : boolean;
var
  i, j : byte;
  TakenFileNums : set of TFileNum;
begin
  with SaveModifiedForm do
    with FileNums do begin
      Clear;
      if (FilesOpen > 0) and Edit.Modified and InCurGroup(FileName) then
        Add(newInteger(0));
      if FilesOpen > 1 then
        for i := 1 to FilesOpen - 1 do
          if MainForm.Files[i]^.Modified and InCurGroup(Files[i]^.FileName) then
            Add(newInteger(i));

      result := (Count = 0) or (ShowModal = mrOK);
    end;//with
  if not result then exit;

  if FilesOpen > 1 then begin
    //handle the Tabs
    for i := FilesOpen - 1 downto 1 do
      if InCurGroup (Files[i]^.FileName) then begin
        j := InvTabFiles (i);
        assert (j <> -1);
        LeftShiftTabFilesAt (j);
        Tabs.Tabs.Delete (j);
      end;

    //separates non group members of Files and puts then at
    //the top of Files array; items in the ViewMnu will be
    //handled with the files
    j := 1;
    for i := 1 to FilesOpen - 1 do
      if not InCurGroup (Files[i]^.FileName) then begin
        if i > j then Files[j]^.Assign (Files[i]^);
        //TabFiles[j] := TabFiles[i] - groups[GroupOpen].Count + 1;
        inc (j);
      end;

    //destroyes the top group members of Files
    for i := FilesOpen - 1 downto j do
      Dispose (Files[i]);

    FilesOpen := j;

    //fix TabFiles
    TakenFileNums := [];//for multiple files w/ same name
    if Tabs.Tabs.Count > 0 then begin
      for i := 0 to Tabs.Tabs.Count - 1 do
        if (Tabs.Tabs[i] = ExtractFileName(FileName)) and not (0 in TakenFileNums) then begin
          TabFiles[i] := 0;
          TakenFileNums := TakenFileNums + [0];
        end else
          for j := 1 to FilesOpen - 1 do
            if not (j in TakenFileNums) and (Tabs.Tabs[i] = ExtractFileName(Files[j]^.FileName)) then begin
              TabFiles[i] := j;
              TakenFileNums := TakenFileNums + [j];
              break;
            end;
    end;//if

  end;//if FilesOpen > 1...

  if InCurGroup (FileName) then begin
    Edit.Modified := false;//already took care of saving
    result := CloseCurFile;
  end;

  //if any files are still open, TabIndex cannot be -1
  if (FilesOpen > 0) then //and (Tabs.TabIndex = -1) then
    Tabs.TabIndex := InvTabFiles(0);//Tabs.TabIndex := 0;

  EnableView;
  GroupOpen := 0;
end;

//returns true only if all files in group are closed
{function TMainForm.CloseOpenGroup : boolean;
var i, j : byte;
begin
  if FilesOpen = 0 then begin
    result := true;
    exit
  end else if FilesOpen > 1 then begin
    //close files other than current file first
    //first save all changes
    for i := 1 to FilesOpen - 1 do
      if Files[i]^.Modified and InCurGroup (Files[i]^.FileName) then
        if  SaveChanges (i, true) = mrCancel then begin
          result := false;
          exit;
        end;

    //handle the Tabs
    for i := FilesOpen - 1 downto 1 do
      if InCurGroup (Files[i]^.FileName) then begin
        j := InvTabFiles (i);
        assert (j <> -1);
        LeftShiftTabFilesAt (j);
        Tabs.Tabs.Delete (j);
      end;

    //separates non group members of Files and puts then at
    //the top of Files array; items in the ViewMnu will be
    //handled with the files
    j := 1;
    for i := 1 to FilesOpen - 1 do
      if not InCurGroup (Files[i]^.FileName) then begin
        if i > j then
          Files[j]^.Assign (Files[i]^);

        inc (j);
      end;

    //destroyes the top group members of Files
    for i := FilesOpen - 1 downto j do
      Dispose (Files[i]);

    FilesOpen := j;
  end;//if FilesOpen > 1...

  if InCurGroup (FileName) then
    result := CloseCurFile
  else
    result := true;

  //if any files are still open, TabIndex cannot be -1
  if (FilesOpen > 0) and (Tabs.TabIndex = -1) then
    Tabs.TabIndex := 0;
  //assert ((FilesOpen = 0) or (Tabs.TabIndex <> -1), 'CloseOpenGroup');

  EnableView;
  GroupOpen := 0;
end;}

function TMainForm.InCurGroup (const fName : TFileName) : boolean;
var i : byte;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  with groups[GroupOpen]^ do
    if Count > 0 then
      for i := 0 to Count - 1 do
        if StrCmpi (Strings[i], fName) then begin
          result := true;
          exit;
        end;

  result := false;
end;

procedure TMainForm.FileCopyMnuClick(Sender: TObject);
begin
  CMForm.mode := cmCopy;
  CMForm.ShowModal;
end;

procedure TMainForm.FileMoveMnuClick(Sender: TObject);
begin
  CMForm.mode := cmMove;
  CMForm.ShowModal;
end;

{prompts to change f1 to f2 in current group; if f1 is
 an untitiled file, f2 is added to the group, if not and
 f1 is not in the group, then the user is not even
 prompted to change f1 to f2; false is returned iff
 f2 is not added to the current group;}
function TMainForm.ChangeGroupFile (const f1, f2 : TFileName) : boolean;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  if groups[GroupOpen]^.IndexOf (f1) = -1 then begin
    if IsUntitled (f1) then
      result := AddToGroup (f2, true)
    else
      result := false;
  end else
    if ConfirmPrompt
    and (MessageDlg ('Do you wish to change "' + f1 + '" to "' + f2 + '" in the current group?',
         mtConfirmation, [mbYes, mbNo], 0) = mrNo) then
      result := false
    else begin
      groups[GroupOpen].Strings[groups[GroupOpen].IndexOf (f1)] := f2;
      result := true;
    end;
end;

procedure TMainForm.FileRenameMnuClick(Sender: TObject);
var fName : TFileName;
begin
  fName := ExtractFileName (FileName);
  if not InputQuery ('Rename', 'Rename "' + ExtractFileName (FileName) + '" to:', fName) then exit;
  if ExtractFilePath (fName) <> '' then begin
    ShowMsgDlg ('You should use "Move" if you want to change to location as well as the name of a file', mtWarning);
    exit;
  end;

  fName := ExtractFilePath (FileName) + fName;
  if FileExistsEx (fName, true) then begin
    if MessageDlg ('File "' + fName + '" exists.  Overwrite?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      if not DeleteFile (fName) then begin
        ShowMsgDlg ('File "' + fName + '" could not be delete so file "' + FileName + '" could be renamed', mtError);
        exit;
      end;
    end else
      exit;
  end;

  if not RenameFile (FileName, fName) then begin
    ShowMsgDlg ('File "' + FileName + '" could not be renamed', mtError);
    exit;
  end;

  ChangeGroupFile (FileName, fName);
  ChangeFavFile (FileName, fName);
  ChangeRecentFile (FileName, fName);
  FileName := fName;
  if LangWordsList.UpdateCurItem(FileName) then ColorCodeAll;
end;

procedure TMainForm.FileDeleteMnuClick(Sender: TObject);
begin
  if ConfirmPrompt then
    if MessageDlg ('Sure you want to DELETE "' + FileName + '"?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  if not DeleteFile (FileName) then begin
    ShowMsgDlg ('Could not delete "' + FileName + '"', mtError);
    exit;
  end;

  RemoveFromRecent (FileName);
  RemoveFromGroup (FileName);
  RemoveFromFav(FileName);
  Edit.Modified := false;
  CloseCurFile;
end;

function TMainForm.RemoveFromGroup (const fName : TFileName) : boolean;
begin
  if not InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if MessageDlg ('Do you want to REMOVE "' + fName + '" from the open group?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
    result := false;
    exit;
  end;

  with groups[GroupOpen]^ do
    Delete (IndexOf (fName));

  result := true;
end;

function TMainForm.AddToGroup (const fName : TFileName; askUser : boolean) : boolean;
begin
  if GroupOpen = 0 then begin
    result := false;
    exit;
  end;

  if InCurGroup (fName) then begin
    result := false;
    exit;
  end;

  if askUser then
    if MessageDlg ('Do you wish to add "' + fName + '" to group "' + CapToStr (FileOpenGroupMnu.Items[GroupOpen - 1].Caption) + '"?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  groups[GroupOpen]^.Add (fName);
  FileName := fName;//rewrites file name in title bar
  result := true;
end;

procedure TMainForm.OptionsOpenFavoritesMnuClick(Sender: TObject);
begin
  FavForm.ShowModal;
end;

function TMainForm.AddToFav (const fName : TFileName) : boolean;
var MenuItem : TFavMenuItem;
begin
  if FileFavoritesMnu.Count >= MAX_FILE_NUM then begin
    result := false;
    exit;
  end;

  if InFav (fName) >= 0 then begin
    result := false;
    ShowMsgDlg ('"' + fName + '" is already in favorites', mtWarning);
    exit;
  end;

  RemoveFromRecent (fName);

  MenuItem := TFavMenuItem.Create (FileFavoritesMnu);
  MenuItem.Caption := StrToCap (fName, FileFavoritesMnu.Count + 1);

  FileFavoritesMnu.Add (MenuItem);
  result := true;
end;

function TMainForm.RemoveFromFav (const fName : TFileName) : boolean;
var i : SmallInt;
begin
  i := InFav(fName);
  if i = -1 then begin
    result := false;
    exit;
  end;

  if MessageDlg ('Do you want to REMOVE "' + fName + '" from the Favorites?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
    result := false;
    exit;
  end;

  FileFavoritesMnu.Delete(i);
  result := true;
end;

{returns the position of fName in favorites; returns 0 if
 fName is not in favorites}
function TMainForm.InFav (const fName : TFileName) : SmallInt;
var i : byte;
begin
  with FileFavoritesMnu do begin
    if Count = 0 then begin
      result := -1;
      exit;
    end;

    for i := 0 to Count - 1 do
      if StrCmpi (CapToStr (fName), CapToStr (Items[i].Caption)) then begin
        result := i;
        exit;
      end;

  end;//with...
  result := -1;
end;

{if OldName is in the favorites menu, then the user is
 prompted to change it to new nane; true is returned iff
 user confirms change OldName to NewName}
function TMainForm.ChangeFavFile (const OldName, NewName : TFileName) : boolean;
var i : integer;
begin
  i := InFav (OldName);
  if i = -1 then begin
    result := false;
    exit;
  end;

  if ConfirmPrompt then
    if MessageDlg ('Do you wish to change "' + OldName + '" to "' + NewName + '" in the favorites menu?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  FileFavoritesMnu.Items[i].Caption := StrToCap (NewName, i + 1);
  result := true;
end;

function TMainForm.ChangeRecentFile (const OldName, NewName : TFileName) : boolean;
var i : integer;
begin
  i := RecentPos (OldName);
  if i = -1 then begin
    result := false;
    exit;
  end;

  if ConfirmPrompt then
    if MessageDlg ('Do you wish to change "' + OldName + '" to "' + NewName + '" in File|Recent?',
                   mtConfirmation, [mbYes,mbNo], 0) = mrNo then begin
      result := false;
      exit;
    end;

  FileRecentMnu.Items[i].Caption := StrToCap (NewName, i + 1);
  result := true;
end;

//returns true only if all files are closed
function TMainForm.CloseAllFiles : boolean;

  procedure DestroyAllOpened;
  var i : TFileNum;
  begin
    AddToRecent (FileName, true);

    if FilesOpen > 0 then
      for i := FilesOpen - 1 downto 1 do begin
        AddToRecent (Files[i]^.FileName, true);
        Dispose (Files[i]);
      end;

    Tabs.Tabs.Clear;
    GroupOpen := 0;
    FilesOpen := 0;
    EnableView;

    Edit.Clear;
    FileName := '';//FileName := '' hides Edit
    LangWordsList.UpdateCurItem(FileName);
   end;

var i : TFileNum;
begin
  if (SaveModifiedForm = nil) or (SaveModifiedForm.FileNums = nil) then begin
    DestroyAllOpened;
    result := true;
  end else
    with SaveModifiedForm do
      with FileNums do begin
        Clear;
        if (FilesOpen > 0) and Edit.Modified then
          Add(newInteger(0));
        if FilesOpen > 1 then
          for i := 1 to FilesOpen - 1 do
            if MainForm.Files[i]^.Modified then
              Add(newInteger(i));

        result := (Count = 0) or (ShowModal = mrOK);
        if result then DestroyAllOpened;
      end;//with...
end;

//returns true only if all files are closed
{function TMainForm.CloseAllFiles : boolean;
var i : TFileNum;
begin
  if FilesOpen = 0 then begin
    result := true;
    exit
  end else if FilesOpen > 1 then begin
    //close files other than current file first
    //first save all changes
    for i := 1 to FilesOpen - 1 do
      if Files[i]^.Modified then
        if SaveChanges (i, true) = mrCancel then begin
          result := false;
          exit;
        end;

    for i := FilesOpen - 1 downto 1 do begin
      AddToRecent (Files[i]^.FileName, true);
      Dispose (Files[i]);
    end;

    FilesOpen := 1;

    //it's easiest to kill all the tabs, then put the one
    //I want there back
    Tabs.Tabs.Clear;
    AddActiveTab (FileName);
  end;//if FilesOpen > 1...

  EnableView;
  result := CloseCurFile;
  GroupOpen := 0;
end;}

procedure TMainForm.HelpContentsMnuClick(Sender: TObject);
begin
  Application.HelpContext (1);
end;

procedure TMainForm.OptionsHintsMnuClick(Sender: TObject);
begin
  HintForm.ShowModal;
end;

procedure TMainForm.ViewSelectFileMnuClick(Sender: TObject);
begin
  ViewForm.ShowModal;
end;

procedure TMainForm.ShowStatusBar (b : boolean);
begin
  ViewStatusBarMnu.Checked := b;
  if b then
    StatusBar1.Height := 16
  else
    StatusBar1.Height := 0;
  Resize;
end;

procedure TMainForm.FileBackupMnuClick(Sender: TObject);
begin
  FileBackupAllFilesMnu.Enabled := FilesOpen > 1;
end;

procedure TMainForm.FileBackupCurrentFileMnuClick(Sender: TObject);
var fName : TFileName;
begin
  if FilesOpen = 0 then exit;

  if IsReadOnly (fName) then begin
    ShowMsgDlg ('This is a readonly file.  If you want to back this file up, use a different name.', mtWarning);
    exit;
  end;

  fName := GetBackupName (FileName);
  Edit.Lines.SaveToFile (fName);
end;

procedure TMainForm.FileBackupAllFilesMnuClick(Sender: TObject);
var
  i : byte;
  FileVar : TextFile;
begin
  FileBackupCurrentFileMnu.Click;
  if FilesOpen < 2 then exit;

  for i := 1 to FilesOpen - 1 do begin
    AssignFile (FileVar, GetBackupName (files[i].FileName));
    Rewrite (FileVar);
      Write (FileVar, files[i].Text);
    CloseFile (FileVar);
  end;
end;

procedure TMainForm.FileCloseCurrentFileMnuClick(Sender: TObject);
begin
  if InCurGroup (FileName) then
    if PersistentGroups then begin
      CloseOpenGroup;
      exit;
    end else
      case MessageDlg ('"' + FileName + '" is in the group currently open.  Do you want to close the ENTIRE group instead of just this file?',
        mtConfirmation, mbYesNoCancel, 0) of
        mrYes : begin
          CloseOpenGroup;
          exit;
        end;

        mrCancel : exit;
      end;//case...

  CloseCurFile;
end;

procedure TMainForm.FileCloseAllFilesMnuClick(Sender: TObject);
begin
  CloseAllFiles;
end;

procedure TMainForm.FileInsertMnuClick(Sender: TObject);
var
  text : string;
  hSS : cardinal;
begin
  //make OpenDialog an InsertDialog
  OpenDlg.Title := 'Insert';
  OpenDlg.Options :=
    OpenDlg.Options + [ofHideReadOnly];

  if not OpenDlg.execute then begin
    //change back to open dialog
    OpenDlg.Title := '';
    OpenDlg.Options :=
      OpenDlg.Options - [ofHideReadOnly];

    exit;
  end;
  //change back to open dialog
  OpenDlg.Title := '';
  OpenDlg.Options :=
    OpenDlg.Options - [ofHideReadOnly];

  if CanOpen (OpenDlg.FileName, true) <> coTrue then exit;

  hSS := Edit.SelStart;

  text := Edit.Text;
  System.Insert (FileToStr (OpenDlg.FileName), text, Edit.SelStart);
  AssignAndColorCode(text);

  Edit.SelStart := hSS;
  OpenDlg.InitialDir := ExtractFilePath (OpenDlg.FileName);
end;

procedure TMainForm.FileUnbackupCurrentFileMnuClick(Sender: TObject);
begin
  DeleteFile (GetBackupName (FileName));
end;

procedure TMainForm.FileUnbackupAllFilesMnuClick(Sender: TObject);
var i : byte;
begin
  FileUnbackupCurrentFileMnu.Click;

  if FilesOpen > 1 then
    for i := 1 to FilesOpen - 1 do
      DeleteFile (GetBackupName (files[i].FileName));
end;

procedure TMainForm.FileReplaceCurrentFileMnuClick(Sender: TObject);
begin
  {So CanOpen will not return coMaxFiles}
  dec (FilesOpen);
  if CanOpen (GetBackupName (FileName), true) = coTrue then
    LoadAndColorCode(GetBackupName(FileName));

  inc (FilesOpen);
  ChangeModify(true);
end;

procedure TMainForm.FileReplaceAllFilesMnuClick(Sender: TObject);
var i : byte;
begin
  {So CanOpen will not return coMaxFiles}
  dec (FilesOpen);
  for i := 1 to FilesOpen do
    if CanOpen (GetBackupName (Files[i]^.FileName), true) = coTrue then begin
      Files[i]^.Text := FileToStr (GetBackupName (Files[i]^.FileName));
      Files[i]^.Modified := true;
    end;

  inc (FilesOpen);

  {since the next procedure calls WriteModifed,
   put it here instead of at the top keep
   WriteModified from having to be called
   twice}
  FileReplaceCurrentFileMnu.Click;
end;

function TMainForm.GetCaretY : cardinal;
begin
  {Returns the Y coordinate of the caret
   reletive to the screen}
  with Edit do
    result := (Perform (EM_LINEFROMCHAR, -1, 0)
      - Perform (EM_GETFIRSTVISIBLELINE, 0, 0))
      * abs (Font.Height) + Top + MainForm.Top;
end;

procedure TMainForm.ShowFoundDlg (FoundOne : boolean);
begin
  if FoundOne then
    ShowMsgDlg ('No more matches for "' + FindText + '" found', mtInformation)
  else
    ShowMsgDlg ('Search string "' + FindText + '" not found', mtInformation);
end;

//takes Params and changes things like PR_TOKEN to FileName
function TMainForm.ExpandParams (var Params : string) : boolean;
var
  FindStr, InParams : string;
  i : cardinal;
  ReplaceSet : set of char;

  //returns the string that $* will be replaced with
  function GetReplaceStr : string;
  begin
    result := GetMainFile;
    if PR_DIRVE_LETTER in ReplaceSet then result := GetDriveLetter (result);
    if PR_DOS_NAME in ReplaceSet then result := ShortNameOf (result);
    if PR_REMOVE_EXTENSION in ReplaceSet then result := ChangeExt (result, '');
    if PR_EXTRACT_PATH in ReplaceSet then result := ExtractFilePath (result);
    if PR_REMOVE_PATH in ReplaceSet then result := ExtractFileName (result);
  end;

begin
  i := Pos (PR_TOKEN, Params);
  while i > 0 do begin
    FindStr := PR_TOKEN;
    ReplaceSet := [];

    while i < length (Params) do begin
      inc (i);
      if not (Params[i] in ValidFilePRs) then break;

      ReplaceSet := ReplaceSet + [Params[i]];
      FindStr := FindStr + Params[i];
    end;//while i < length...
  Replace (FindStr, GetReplaceStr, Params);
  i := Pos (PR_TOKEN, Params);
  end;//while i > 0...

  //replaces %p with parameters that were prompted for
  i := pos (PR_PROMPT, Params);
  while i > 0 do begin
    if not InputQuery ('Parameters', 'Input Parameters', InParams) then
      if MessageDlg ('Do you still want to execute this program', mtConfirmation, [mbYes, mbNo], 0) = mrNo then begin
        result := false;
        exit;
      end;

      Replace (PR_PROMPT, InParams, Params);
      i := pos (PR_PROMPT, Params);
    end;

  result := true;
end;

{Saves the currently selected text to a file}
procedure TMainForm.FileSelectionSaveMnuClick(Sender: TObject);
begin
  SaveDlg.Title := 'Save Selection';
  SaveDlg.FileName := NextUntitledName;

  if not SaveDlg.execute then begin
    SaveDlg.Title := '';
    exit;
  end;
  SaveDlg.Title := '';

  if FileExistsEx (SaveDlg.FileName, true) then
    if MessageDlg (SaveDlg.FileName + ' exists.  Overwrite?', mtWarning, [mbYes, mbNo], 0) = mrNo then
      exit; //Modified still = true

  SelectionToFile (SaveDlg.FileName);
end;

{creates a new file and puts the text
 currently highlighted into it}
procedure TMainForm.FileSelectionOpenMnuClick(Sender: TObject);
var HoldSel : string;
begin
  HoldSel := Edit.SelText;
  NewFile(NextUntitledName, false);
  AssignAndColorCode(HoldSel);
  ChangeModify(true);
end;

procedure TMainForm.ExecuteExplorerMnuClick(Sender: TObject);
begin
  Execute ('Explorer ' + ExtractFilePath (FileName));
end;

procedure TMainForm.OptionsSyntaxMnuClick(Sender: TObject);
begin
  SyntaxHighlightingForm.ShowModal;
end;

procedure TMainForm.ViewMainFileMnuClick(Sender: TObject);
var i : cardinal;
begin
  for i := 1 to FilesOpen - 1 do
    if StrCmpi (Files[i]^.FileName, groups[GroupOpen]^.Strings[MainFile[GroupOpen]]) then
      ClickTabFile (Sender, i);
end;

procedure TMainForm.AddFavoritesMnuClick(Sender: TObject);
begin
  AddToFav (FileName);
end;

procedure TMainForm.PopupMenuPopup(Sender: TObject);
begin
  OpenGroupPopItem.Enabled := FileOpenGroupMnu.Count > 0;
  AddToPopItem.Items[0].Enabled := InFav (FileName) < 0;
  AddToPopItem.Items[1].Enabled := (GroupOpen > 0) and not InCurGroup (FileName);
  ClosePopItem.Items[2].Enabled := GroupOpen > 0;
end;

procedure TMainForm.OptionsPropertiesMnuClick(Sender: TObject);
begin
  PropertiesForm.ShowModal;
end;

procedure TMainForm.OptionsOpenRecentMmuClick(Sender: TObject);
begin
  RecentForm.ShowModal;
end;

procedure TMainForm.EditIndentBlockMnuClick(Sender: TObject);
begin
  IndentWith(' ');
end;

procedure TMainForm.EditUnindentBlockMnuClick(Sender: TObject);
var
  deleted, i, start, stop : Integer;
  str : TStringList;
begin
  with Edit do begin
    {ReadOnly files shouldn't be able to be modified like
     this, but the code here would modify it anyway}
    if ReadOnly then exit;

    //i acts as start now
    start := Perform (EM_LINEFROMCHAR, -1, 0);
    stop := Perform (EM_LINEFROMCHAR, SelStart + SelLength - 1, 0);
    {if SelLength = 0, then stop = start - 1 which keeps
     the for loop below from executing once like I want}
    if stop < start then stop := start;

    SaveEditAttributes;
    str := TStringList.Create;
    //I need to count the number of chars deleted to adjust SelLength
    deleted := 0;
    for i := start to stop do
      if (Lines[i] <> '') and ((Lines[i][1] = ' ') or (Lines[i][1] = chr(VK_TAB))) then begin
        str.Add (copy (Lines[i], 2, length (Lines[i]) - 1));
        inc (deleted);
      end else str.Add (Lines[i]);

    RedrawOn := false;
    //Clear so changes to Text wasn't cause color coding
    if ColorCodingAvaliable then SelectionStatus.Clear;
    {it still works propertly w/o the if; it's for
     efficiency and to prevent Modified being set when
     nothing was changed}
    if deleted > 0 then begin
      //see EditIndentBlockMnuClick for explanation
      SelStart := Perform (EM_LINEINDEX, start, 0);
      if stop + 1 >= Lines.Count then
        SelLength := GetTextLen - SelStart
      else
        SelLength := Perform (EM_LINEINDEX, stop + 1, 0) - SelStart - 2;
      inc(PauseColorCoding);
      SelText := copy(str.Text, 1, length(str.Text) - 2);
      dec(PauseColorCoding);
    end;
    str.Free;

    LoadEditAttributes;
    if SelLength = 0 then begin
      assert(start = stop);
      {InvalidateLines is called after RedrawOn so the
       line will be invalidated when color coding is off}
      ColorCodeLines(start, stop, false);
      RedrawOn := true;
      InvalidateLines(start, stop);
    end else begin
      SelLength := SelLength - deleted;
      RedrawOn := true;
      InvalidateLines(start, stop);
      if ColorCodingAvaliable then
        SelectionStatus.SetWithLines(start, stop);
    end;
  end;//with
  WriteModified;
end;

procedure TMainForm.TabsChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  PrevTabIndex := Tabs.TabIndex;
end;

procedure TMainForm.TabsChange(Sender: TObject);
begin
  if Tabs.TabIndex = PrevTabIndex then exit;
  SwapEditAry (TabFiles[Tabs.TabIndex]);
end;

procedure TMainForm.ViewShowClipMnuClick(Sender: TObject);
begin
  with ViewShowClipMnu do begin
    Checked := not Checked;
    if Checked then
      CBtoPanel
    else
      StatusBar1.Panels[PN_CLIP].Text := '';
  end;
end;

procedure TMainForm.ViewScrollBarsMnuClick(Sender: TObject);
begin
  ViewScrollBarsMnu.Checked := not ViewScrollBarsMnu.Checked;
  SetScrollBars;
end;

procedure TMainForm.ViewStatusBarMnuClick(Sender: TObject);
begin
  ShowStatusBar (not ViewStatusBarMnu.Checked);
end;

procedure TMainForm.ViewToolBarMnuClick(Sender: TObject);
begin
  ShowToolBar (not ViewToolbarMnu.Checked);
end;

procedure TMainForm.ViewTabsMnuClick(Sender: TObject);
begin
  ShowTabs (not ViewTabsMnu.Checked);
end;

procedure TMainForm.ShowTabs (b : boolean);
begin
  ViewTabsMnu.Checked := b;
  Tabs.Visible := b;
end;

procedure TMainForm.AddGroupMnuClick(Sender: TObject);
begin
  AddToGroup (FileName, false);
end;

procedure TMainForm.OptionsFiltersMnuItemClick(Sender: TObject);
begin
  FiltersForm.ShowModal;
end;

procedure TMainForm.ClipboardDualMnuClick(Sender: TObject);
begin
  ClipType := CT_DUAL;
end;

procedure TMainForm.ClipboardStackMnuClick(Sender: TObject);
begin
  ClipType := CT_STACK;
end;

procedure TMainForm.ClipboardQueueMnuClick(Sender: TObject);
begin
  ClipType := CT_QUEUE;
end;

procedure TMainForm.ClipboardSwapClipMnuClick(Sender: TObject);
begin
  Clips.Insert (0, Clipboard.AsText);
  if Clips.Count = 2 then begin
    Clipboard.AsText := Clips.Strings[1];
    Clips.Delete (1);
  end else
    Clipboard.AsText := '';

  assert (Clips.Count < 2, 'ClipboardsSwampClickMnuClick');
  CBtoPanel;
end;

procedure TMainForm.EditChangeCaseLowerMnuClick(Sender: TObject);
begin
  ChangeCaseWith(LowerCase);
end;

procedure TMainForm.EditChangeCaseUpperMnuClick(Sender: TObject);
begin
  ChangeCaseWith(UpperCase);
end;

procedure TMainForm.EditChangeCaseTitleMnuClick(Sender: TObject);
begin
  ChangeCaseWith(TitleCase);
end;

procedure TMainForm.EditChangeCaseToggleMnuClick(Sender: TObject);
begin
  ChangeCaseWith(ToggleCase);
end;

procedure TMainForm.EditMnuClick(Sender: TObject);
begin
  EditChangeCaseMnu.Enabled := Edit.SelLength > 0;
end;

procedure TMainForm.InvalidateChars(pos : integer);
var
  rect : TRect;
  point : TPoint;
begin
  with Edit do begin
    Perform(EM_POSFROMCHAR, LongInt(@point), pos);
    rect.Top := point.y; rect.Left := point.x;

    pos := Perform(EM_LINEFROMCHAR, pos, 0) + 1;
    if pos >= Lines.Count then
      rect.Bottom := Height
    else begin
      pos := Perform(EM_LINEINDEX, pos, 0);
      Perform(EM_POSFROMCHAR, LongInt(@point), pos);
      rect.Bottom := point.y;
    end;

    rect.Right := Width;
    InvalidateRect(Handle, @rect, true);
    Update;
  end;
end;

procedure TMainForm.InvalidateLines(start, stop : integer);
var
  rect : TRect;
  point : TPoint;
begin
  with Edit do begin
    start := Perform(EM_LINEINDEX, start, 0);
    Perform(EM_POSFROMCHAR, LongInt(@point), start);
    rect.Top := point.y;

    stop := Perform(EM_LINEINDEX, stop + 1, 0);
    if stop = -1 then
      rect.Bottom := Edit.Height
    else begin
      Perform(EM_POSFROMCHAR, LongInt(@point), stop);
      rect.Bottom := point.y;
    end;
    rect.Left := 0;
    rect.Right := Width;
    InvalidateRect(Handle, @rect, true);
    Update;
  end;
end;

procedure TMainForm.ColorCodeWord(caretPos : integer);
var j, start, stop : integer;
begin
  if (PauseColorCoding > 0) or not ColorCodingAvaliable then exit;
  assert(0 <= caretPos);
  assert(caretPos <= Edit.GetTextLen);

  {to prevent this function from calling itself
   through EditChange}
  inc(PauseColorCoding);

  with Edit do begin
    //Repaint;
    RedrawOn := false;
    SaveAllEditAttributes;

    start := caretPos; stop := caretPos;
    while (start > 1) and not IsWhiteSpace(Text[start - 1]) do
      dec(start);
    while (stop < GetTextLen) and not IsWhiteSpace(Text[stop + 1]) do
      inc(stop);

    with LangWordsList do
        with Parses do begin
          ParseLine(copy(Text, start, stop - start + 1));
          if Items.Count > 0 then
            for j := 0 to Items.Count - 1 do begin
              //- 1 since Items[x].Start is 1 based
              SelStart := start - 1 + Items[j].Start - 1;
              SelLength := Items[j].Length;
              case Items[j].Kind of
                tkPlainText : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> DefAttributes.Color) then SelAttributes.Color := DefAttributes.Color;
                tkSymbol : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> SymbolsColor) then SelAttributes.Color := SymbolsColor;
                tkKeyWord : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> KeyWordsColor) then SelAttributes.Color := KeyWordsColor;
              end;
            end;
        end;

    if HasEditHorzScrollPosChanged then begin
      LoadAllEditAttributes;
      RedrawOn := true;
      Edit.Repaint;
    end else begin
      LoadAllEditAttributes;
      RedrawOn := true;
      InvalidateChars(max(Perform(EM_LINEINDEX, Perform(EM_LINEFROMCHAR, start, 0), 0), start - 1));
    end;

    dec(PauseColorCoding);
  end;//with Edit
end;

procedure TMainForm.ColorCodeLines(start, stop : integer; DoInvalidate : boolean);
var i, j, lineIndex : integer;
begin
  if (PauseColorCoding > 0) or not ColorCodingAvaliable then exit;
  assert(start <= stop);
  assert(0 <= start);
  assert(stop < Edit.Lines.Count);

  if (stop - start > 30) then begin
    ColorCodeAll;
    exit;
  end;

  with Edit do begin
    //if start = Lines.Count - 1 then dec(start);
    //if stop = Lines.Count - 1 then dec(stop);
    //if stop < 0 then exit;

    {to prevent this function from calling itself
     through EditChange}
    inc(PauseColorCoding);

    RedrawOn := false;
    SaveAllEditAttributes;

    with LangWordsList do
      for i := start to stop do
        with Parses do begin
          ParseLine(Lines[i]);
          //- 1 since Items[x].Start is 1 based
          lineIndex := Perform(EM_LINEINDEX, i, 0) - 1;
          if Items.Count > 0 then
            for j := 0 to Items.Count - 1 do begin
              SelStart := lineIndex + Items[j].Start;
              SelLength := Items[j].Length;
              case Items[j].Kind of
                tkPlainText : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> DefAttributes.Color) then SelAttributes.Color := DefAttributes.Color;
                tkSymbol : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> SymbolsColor) then SelAttributes.Color := SymbolsColor;
                tkKeyWord : if not (caColor in SelAttributes.ConsistentAttributes) or (SelAttributes.Color <> KeyWordsColor) then SelAttributes.Color := KeyWordsColor;
              end;
            end;
        end;

    LoadAllEditAttributes;

    RedrawOn := true;
    if DoInvalidate then InvalidateLines(start, stop);
    dec(PauseColorCoding);
  end;//with Edit
end;

procedure TMainForm.ColorCodeAll;
begin
  SaveAllEditAttributes;
  AssignAndColorCode(Edit.Text);
  LoadAllEditAttributes;
  Edit.Repaint;
end;

procedure TMainForm.EditChange(Sender: TObject);
begin
  with Edit do
    if (0 <= SelStart) and (SelStart <= GetTextLen) then
      ColorCodeWord(SelStart);
end;

procedure TMainForm.EditSelectionChange(Sender: TObject);
begin
  with SelectionStatus do
    if Status then begin
      Clear;
      ColorCodeLines(Start, Stop, true);
      InvalidateChars(Edit.SelStart);//erases ghost caret
    end;
end;

procedure TMainForm.EditInsertTimeMnuClick(Sender: TObject);
begin
  InsertAtPos(TimeToStr(Time), Edit.SelStart);
end;

procedure TMainForm.EditInsertDateMnuClick(Sender: TObject);
begin
  InsertAtPos(DateToStr(Date), Edit.SelStart);
end;

procedure TMainForm.EditInsertTimeAndDateMnuClick(Sender: TObject);
begin
  InsertAtPos(DateTimeToStr(Now), Edit.SelStart);
end;

procedure TMainForm.FileUnbackupMnuClick(Sender: TObject);
begin
  FileUnbackupAllFilesMnu.Enabled := FilesOpen > 1;
end;

procedure TMainForm.FileReplaceMnuClick(Sender: TObject);
begin
  FileReplaceAllFilesMnu.Enabled := FilesOpen > 1;
end;

{METHODS OF OBJECTS OTHER THAN TMainForm;
 They're not in CE_Unit because they use
 TMainForm}

procedure TRunMenuItem.Click;
var Params, BatFile : string;
begin
  with MainForm do
    if FilesOpen > 0 then
      case Progs[Self.Tag]^.SaveOrBackupIndex of
        0 : begin
        FileSaveMnu.Click;

          if Edit.Modified then //save was cancled
            if MessageDlg ('Still wish to Run Program?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
              exit;
        end;

        1 : begin
          FileSaveAllMnu.Click;

          {If any files are modified, some save
           must have been cancled}
          if AnyModified then
            if MessageDlg ('Still wish to Run Program?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
              exit;
        end;

        2 : FileBackupCurrentFileMnu.Click;
        3 : FileBackupAllFilesMnu.Click;
      end;//case

  Params := MainForm.Progs[Tag]^.Params;
  if not MainForm.ExpandParams (Params) then exit;
  Params := MainForm.Progs[Tag]^.Prog + ' ' + Params;

  if MainForm.Progs[Tag]^.BatFile.Text = '' then
    Execute (Params)
  else begin
    BatFile := MainForm.Progs[Tag]^.BatFile.Text;
    MainForm.ExpandParams (BatFile);
    ReplaceAll ('%cmd%', Params, BatFile);

    DeployBatFile (BatFile);
  end;
end;

procedure TRecentMenuItem.Click;
begin
  {since MainForm.RemoveFromRecent cannot call Suicide,
   it sets tag = 1 and calls click instead}
  if tag = 1 then
    Suicide
  else if MainForm.OpenFile (CapToStr (Caption), true) = coNotExists then
    Suicide;
end;

procedure TRecentMenuItem.Suicide;
var i : byte;
begin
  if MainForm.ConfirmPrompt then
    if MessageDlg ('Do you with to DELETE "' + CapToStr (Caption) + '" from the "File|Open Recent" menu?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  i := MenuIndex + 1;
  with MainForm.FileRecentMnu do
    while (i <= 9) and (i < Count) do begin
      with Items[i] do
        Caption := StrToCap (CapToStr (Caption), i);

      inc (i);
    end;

  MainForm.FileRecentMnu.Remove (self);
end;

procedure TGroupMenuItem.Click;
var i : byte;
begin
  //if MainForm.PersistentGroups then begin
    if not MainForm.CloseAllFiles then exit;
  //end else if MainForm.GroupOpen <> MenuIndex + 1 then
  //  if not MainForm.CloseOpenGroup then exit;

  MainForm.GroupOpen := MenuIndex + 1;
  if MainForm.groups[MenuIndex + 1]^.Count > 0 then begin
    i := 0;
    while (i < MainForm.groups[MenuIndex + 1]^.Count) do
      if not MainForm.IsOpen (MainForm.groups[MenuIndex + 1]^[i]) then
        if MainForm.OpenFileBack (MainForm.groups[MenuIndex + 1]^[i], true, not MainForm.Edit.Visible) <> coTrue then
          if MessageDlg ('Do you wish to DELETE "' +
                         MainForm.groups[MenuIndex + 1]^[i] +
                         '" from ' + CapToStr (Caption) + '?', mtConfirmation,
                         [mbYes, mbNo], 0) = mrYes then
            MainForm.groups[MenuIndex + 1]^.delete (i)
          else inc (i)
        else inc (i)
      else inc (i);
  end;// if...

  {puts groups name into FileName if it was already opened
   and so did not have it put there}
  MainForm.FileName := MainForm.FileName;
end;

procedure TGroupMenuItem.Assign (Source : TPersistent);
var
  i : cardinal;
  MenuItem : TMenuItem;
begin
  MenuItem := TMenuItem (Source);

  Caption := StrToCap (CapToStr (MenuItem.Caption), MenuIndex + 1);
  ShortCut := MenuItem.ShortCut;

  if MenuItem.Count = 0 then exit;
  for i := 0 to MenuItem.Count - 1 do
    Items[i].Caption := MenuItem[i].Caption;
end;

procedure TFavMenuItem.Click;
var fName : TFileName;
begin
  fName := CapToStr (MainForm.FileFavoritesMnu.Items[MenuIndex].Caption);
  if MainForm.OpenFile (fName, true) = coTrue then exit;
  if MainForm.ConfirmPrompt and (MessageDlg ('Do you wish to REMOVE "' + fName + '" from the favorites menu?',
                 mtConfirmation, [mbYes, mbNo], 0) = mrNo) then exit;
  Suicide;
end;

procedure TFavMenuItem.Suicide;
var i : byte;
begin
  i := MenuIndex + 1;
  with MainForm.FileFavoritesMnu do
    while (i <= 9) and (i < Count) do begin
      with Items[i] do
        Caption := StrToCap (CapToStr (Caption), i);

      inc (i);
    end;

  MainForm.FileFavoritesMnu.Remove (self);
end;


constructor TTabUse.Init;
begin
  UseSpaces  := false; TabSize := 8;
end;

procedure TTabUse.Load (const cb : TCheckBox; const se : TSpinEdit);
begin
  UseSpaces := cb.Checked; TabSize := se.Value;
  MainForm.TabStops := TabSize;
end;

procedure TTabUse.LoadFromFile (var FileVar : TextFile);
begin
  ReadLn (FileVar, TabSize);//TabSize used as temp
  UseSpaces := IntToBool(TabSize);
  ReadLn (FileVar, TabSize);
  MainForm.TabStops := TabSize;
end;

procedure TTabUse.SaveToFile (var FileVar : TextFile);
begin
  WriteLn (FileVar, Ord(UseSpaces));
  WriteLn (FileVar, TabSize);
end;

procedure TTabUse.Store (var cb : TCheckBox; var se : TSpinEdit);
begin
  cb.Checked := UseSpaces; se.Value := TabSize;
end;

procedure TMainForm.EditIndentTabMnuClick(Sender: TObject);
begin
  IndentWith(chr(VK_TAB));
end;

procedure TMainForm.FileRecycleMnuClick(Sender: TObject);
begin
  if ConfirmPrompt then
    if MessageDlg ('Sure you want to RECYCLE "' + FileName + '"?',
                   mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

  if not RecycleFile(FileName) then begin
    ShowMsgDlg ('Could not recycle "' + FileName + '"', mtError);
    exit;
  end;

  RemoveFromRecent (FileName);
  RemoveFromGroup (FileName);
  Edit.Modified := false;
  CloseCurFile;
end;

end.
